SystemOrganization addCategory: #'TOC-Dynamic-Dep'!
SystemOrganization addCategory: #'TOC-Dynamic-Core'!
SystemOrganization addCategory: #'TOC-Dynamic-Data'!
SystemOrganization addCategory: #'TOC-Declaration-Core'!
SystemOrganization addCategory: #'TOC-Declaration-Visitor'!
SystemOrganization addCategory: #'TOC-Tracking-Core'!
SystemOrganization addCategory: #'TOC-Tracking-UCatg'!
SystemOrganization addCategory: #'TOC-Tracking-Visitor'!
SystemOrganization addCategory: #'TOC-Dynamic-Metrics'!

!UndeclaredVariableWarning methodsFor: '*toc-warning' stamp: 'OzC 8/2/2012 08:45'!
freeVariableName
	^ name! !

!MCVersionLoader methodsFor: '*toc-monticello-override' stamp: 'OzC 7/30/2012 07:41'!
confirmMissingDependency: aDependency
	| name |
	self flag: #toy.
	name := aDependency versionInfo name.
	TOYProject log: ('missing-dep, ', name).
	"(self confirm: 'Can''t find dependency ', name, '. ignore?')
		ifFalse: [self error: 'Can''t find dependency ', name]"! !

!MCVersionLoader methodsFor: '*toc-monticello-override' stamp: 'OzC 7/27/2012 01:14'!
warnAboutLosingChangesTo: versionCollection
self flag: #toy.
	"self notify: (String streamContents: [:s |
		s nextPutAll: 'You are about to load new versions of the following packages that have unsaved changes in the image.  If you continue, you will lose these changes.'; cr.
		versionCollection do:
			[:ea |
			s cr; space; space; nextPutAll: ea package name]])"! !

!HapaoTestCoverage methodsFor: '*toc-reporting' stamp: 'OzC 11/20/2012 10:57'!
mthCoverage
 ^ (self nonAbstractMthCovered size / self numberOfNonAbstractMethods) asFloat! !

!HapaoTestCoverage methodsFor: '*toc-reporting' stamp: 'OzC 11/20/2012 10:49'!
nonAbstractMthCovered
 ^ (self allNonAbstractMethods select: #isCovered)! !

!HapaoTestCoverage methodsFor: '*toc-reporting' stamp: 'OzC 11/20/2012 10:55'!
reportHapao
	^{
	self averageMethodsPerTest  .
	self numberOfTestMethods .
	self numberOfTestedMethods .
	self ratioCoveredClasses .
	self ratioCoveredClasses .
	self coverage .
	self mthCoverage
	}! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 3/9/2012 00:40'!
isLastStatement
	^ parent isSequence and: [parent statements last == self]! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 3/22/2012 13:49'!
nextMsgParent 
	|nparent|
	nparent := self parent .
	((nparent isMessage) or: 
		[self isLastStatement and: [
			nparent:= nparent parent .
			nparent isBlock ifFalse: [^nil].
			nparent := nparent parent .
			nparent isMessage]]) ifFalse: [^ nil].
	^nparent ! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 3/23/2012 12:44'!
selectFrom: ls
	|nparent|
	nparent := self.
	[nparent := nparent nextMsgParent.
	 nparent ifNil: [^nil]. "Aqui se restrigue solo a selectores permitos, como los de TOUComplex"
	 (ls includes: nparent selector) not] whileTrue .
	^ nparent 
	! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 12:35'!
uCatg 
	^ self propertyAt: #ucatg ifAbsentPut: [(TOUCategory categorize: self) asOrderedCollection].
	! !

!RBValueNode methodsFor: '*toc-tracking' stamp: ''!
with0Arg
	^ #metaObject
		run: #selector
		with: #()
		in: self! !

!RBValueNode methodsFor: '*toc-tracking' stamp: ''!
with1arg: v1 
^ #metaObject run: #selector with: {v1} in: self  ! !

!Behavior methodsFor: '*toc-dynamic' stamp: 'OzC 8/4/2012 16:52'!
allFinalSubclasses
	^ self allSubclasses select: #isFinal! !

!Behavior methodsFor: '*toc-dynamic' stamp: 'OzC 8/4/2012 16:52'!
isFinal
	^ self subclasses isEmpty! !

!MCPackage methodsFor: '*toc-monticello' stamp: 'OzC 12/21/2011 13:25'!
projectName 
	^ self name copyUpTo: $-! !

FMthDef subclass: #TOMCMethodDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!RBParser class methodsFor: '*toc-declaration' stamp: 'OzC 12/16/2011 20:57'!
permissiveParseMethod: source
	[^ RBParser parseMethod: source] on: Error do: [:e | Transcript cr; show: e].
	^ RBParser parseMethod: 'notValidMethodFailToParse'! !

!RBParser class methodsFor: '*toc-declaration' stamp: ''!
with1arg: v1 
^ #metaObject run: #selector with: {v1} in: self  ! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 15:07'!
cleanUOverloads
	"assert" "higho" "flow"
	{ #isHighOrder . #isTest . #isFlow} do: [:sel |
		(self uCatg anySatisfy: sel) ifTrue: [
			self uCatg removeAllSuchThat: [:f | (f perform: sel) not "and: [f isComplex not]"].
		^self].
		].! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/2/2012 13:03'!
hasComplex
	^ (self uCatg select: #isComplex) notEmpty ! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 16:06'!
isAComplex
	^ (self uCatg select: #isComplex) notEmpty ! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 15:13'!
isAFlow 
	^ (self uCatg select: #isFlow) notEmpty! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 15:13'!
isAHighO
	^ (self uCatg select: #isHighOrder) notEmpty! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 4/11/2012 15:13'!
isATest
	^ (self uCatg select: #isTest) notEmpty! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 3/19/2012 13:10'!
uCatg
	^ expr uCatg 
	! !

!Magnitude methodsFor: '*toc-dynamic' stamp: 'OzC 9/9/2013 19:12'!
max: aMagnitude 
	"Answer the receiver or the argument, whichever has the greater 
	magnitude."
	aMagnitude ifNil: [^ self].
	self > aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!MCClassDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/18/2012 17:56'!
hasInstanceVariable: varName metaClass: isMeta
	^ (isMeta 
		ifTrue: [(self selectVariables: #isClassInstanceVariable) 
				union: (self selectVariables: #isClassVariable)] 
		ifFalse: [self selectVariables: #isInstanceVariable]) includes: varName! !

!MCClassDefinition methodsFor: '*toc-declaration' stamp: 'OzC 9/13/2013 21:53'!
numberOfChildrenIn: mcVersion
	^ (mcVersion allClassDef select: [:cls | cls superclassName = self className]) size! !

!SequenceableCollection methodsFor: '*toc-fix' stamp: 'OzC 7/30/2012 20:03'!
sortBy: aBlock
	"Create a copy that is sorted.  Sort criteria is the block that accepts two arguments.
	When the block is true, the first arg goes first ([:a :b | a > b] sorts in descending
	order)."
	
	^ self asOrderedCollection
			sort: aBlock;
	 		yourself! !

!Symbol methodsFor: '*toc-declaration' stamp: 'OzC 1/26/2012 08:19'!
todPattern
	1 to:  self size do: [:i| |chr|
		chr:= self at: i.
		(chr isUppercase) "| (chr = $:)" ifTrue: [^ self first: (i-1)]].
	^  nil
	! !

!Symbol methodsFor: '*toc-declaration' stamp: 'OzC 1/26/2012 08:22'!
todPropertyName
	|ptt|
	ptt := self todPattern .
	ptt ifNil: [^ nil].
	^ self  last: (self size - ptt size)! !

!MCPackageLoader methodsFor: '*toc-monticello-override' stamp: 'OzC 7/30/2012 07:41'!
dependencyWarning
	TOYProject log: ('missing-cls, ', requirements asCommaString withoutQuoting).
	^ String streamContents:
		[:s |
		s nextPutAll: 'This package depends on the following classes:'; cr.
		requirements do: [:ea | s space; space; nextPutAll: ea; cr].
		s nextPutAll: 'You must resolve these dependencies before you will be able to load these definitions: '; cr.
		unloadableDefinitions do: [:ea | s space; space; nextPutAll: ea summary; cr]] ! !

!MCPackageLoader methodsFor: '*toc-monticello-override' stamp: 'OzC 7/30/2012 07:18'!
warnAboutDependencies 
	self flag: #toy.
	"self notify:" self dependencyWarning! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/6/2012 00:24'!
allClassDef
	^ snapshot definitions select: [:def| def isPureClsDef]
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/25/2012 10:12'!
anyClassNameSatisfy: name
	snapshot definitions anySatisfy: [:def | def classNameSatisfy: name]! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 4/8/2012 23:52'!
classNames 
	^ ( self snapshot definitions select: #isMethodDefinition) collect: #className! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 4/11/2012 18:50'!
classNamesTo: ls
	self snapshot definitions do: [:def |
		def isClassDefinition ifTrue:[
			ls do: [:tos | 
				( ('*',tos selector todPropertyName,'*') match: def className) ifTrue: [
					tos iclassNames add: def className.
					]				
				]
			]
		]! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 4/11/2012 17:18'!
classPartiallyNamed: name withSelector: selector
	|ls|
	ls := OrderedCollection new.
	snapshot definitions do: [:def | 
		(def isClassDefinition 
			and: [( ('*',name,'*') match: def className)] ) 
				ifTrue: [ls add: def className ]].
	^ ls! !

!MCVersion methodsFor: '*toc-dynamic' stamp: 'OzC 9/14/2013 11:22'!
complexity
	"mth metrics -> cls metrics -> pkg metrics"
	"mth(avg): mthComplexity, numCond, cycloNum2"
	"cls(avg): wmc -> sum(cycloNum2), sym(mthCompl) , open classes and traits arent counted
	pkg: sum(cycloNum2) sum(mthCompl) "
	|mdict mths mc clss cc pkgs|
	mdict := Dictionary new.
	mths := {0 . 0 . 0}.
	
	(self snapshot definitions select: #isMethodDefinition) do: [:mdef| |cls ls|
		cls := mdict at: mdef className ifAbsentPut: [OrderedCollection new].
		ls := mdef complexityMetrics.
		cls add: ls.
		mc := mc +1.
		mths := mths with: ls  collect: #+.	
		].
	self allClassDef do: [:cls| 
		
		].
	
	^ mdict
	
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/23/2012 11:42'!
findUsagesIn: tod
	snapshot definitions do: [:def |
		def findUsagesIn: tod mcVersion: self.] displayingProgress: 'Inspecting: ', self package projectName 
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/21/2011 13:24'!
isInTop1000 
	^ FSource cachedPkgCtg includesKey: self package projectName ! !

!MCVersion methodsFor: '*toc-dynamic' stamp: 'OzC 8/9/2012 11:02'!
isMCInstalled
	^ (SystemOrganization categoriesMatching: (self package name, '*') ) notEmpty! !

!MCVersion methodsFor: '*toc-dynamic' stamp: 'OzC 8/9/2012 11:02'!
isPkgInstalled
	^ (SystemOrganization categoriesMatching: (self package projectName, '*')) notEmpty! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/23/2012 11:42'!
loadDeclarationIn: "(TOProject)"toc 
	snapshot definitions do: [:def |
		def loadDeclarationIn: toc mcVersion: self.] displayingProgress: 'Loading: ', self package projectName 
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 4/8/2012 23:49'!
mthNames 
	^ ( self snapshot definitions select: #isMethodDefinition) collect: #tocName! !

!MCVersion methodsFor: '*toc-dynamic' stamp: 'OzC 9/13/2013 21:55'!
nocAvgMax
	|avg max n|
	n := 0. max := 0. avg:= 0.
	self allClassDef do: [:def | |dit|
		dit := def numberOfChildrenIn: self .
		n:= n + 1.	max:= max max: dit.  	avg := avg + dit.].
	^n = 0 ifTrue: [{0 . 0}] ifFalse: [{avg / n asFloat. max}]! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 4/12/2012 11:07'!
selectorNames 
	^ (snapshot definitions select: #isMethodDefinition thenCollect: #selector) asSet! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 2/4/2013 00:54'!
testClasses 
	|ccached mcached classes|

 	classes := Set new.
	ccached := Set new.
	mcached := Set new.
	snapshot definitions do: [:def |
		
		(def isPureClsDef and: [(def isTestCaseIn: self )]) ifTrue: [
			(mcached includes: def className) 
				ifTrue: [  classes add: def className ]
				ifFalse: [ ccached add: def className.]
			].
		(def isMethodDefinition and: [def isTestMethod]) ifTrue: [
			(ccached includes: def className) 
				ifTrue: [ classes add: def className ]
				ifFalse: [ mcached add: def className.]
			].
		].
	^ classes
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/6/2012 00:21'!
testMethods
	^ self selectorNames select: [:sel | 'test*' match: sel]! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/19/2012 10:31'!
findUsagesIn: toc mcVersion: mcVersion
	! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: toc mcVersion: mcVersion
	! !

!Profiler methodsFor: '*toc-reporting' stamp: 'OzC 11/20/2012 10:34'!
reportGlobal
	^ {
	"self numberOfLinesOfCode .
	self numberOfClasses .
	self numberOfMethods ."
	unitTestResult runCount .
	unitTestResult passedCount .
	unitTestResult unexpectedFailureCount .
	unitTestResult unexpectedErrorCount }! !

FDataVisitor subclass: #TOTrackingVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Visitor'!

!TOTrackingVisitor commentStamp: '<historical>' prior: 0!
TOTrackingVisitor has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	mthDef	FMthDef 
	fusages	OrderedCollection 
	usages	(Selector -> OrderedCollection )!

!TOTrackingVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/21/2012 15:24'!
onDef: def find: dict
	^ (self on: dict) def: def ; visit: (RBParser permissiveParseMethod: def source) ; yourself ! !

!TOTrackingVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 22:03'!
acceptLiteralNode: aLiteralNode
	|value|
	value := aLiteralNode value.
	value isSymbol ifFalse: [^ self].
	dict  keysAndValuesDo: [:selector :ls |
		"" "This only affect to nil and to empty, but I dont think is significant"
		(ls acceptLiteralSelector: value) ifTrue: [ ls  senders add: (FIdentifierDef newFrom: def andParentExpr: aLiteralNode parent) ]
		].
	! !

!TOTrackingVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 12:23'!
acceptMessageNode: msgNode
	super acceptMessageNode: msgNode.

	dict do: [ :ls |
		(ls acceptSelector: msgNode) ifTrue: [ 
			ls senders add: (FMessageDef newFrom: def andMsg: msgNode).
			^ self ]
		]! !

!EcoProject methodsFor: '*toc-tracking' stamp: 'OzC 4/8/2012 23:56'!
classNames 
	^ self versions last mcVersion classNames ! !

!EcoProject methodsFor: '*toc-dynamic' stamp: 'OzC 7/25/2012 15:49'!
hasTestCase
	^ self versions last mcVersion hasTestCase! !

!EcoProject methodsFor: '*toc-tracking' stamp: 'OzC 4/8/2012 23:44'!
isInTop1000 
	^ FSource cachedPkgCtg includesKey: self projectName ! !

!EcoProject methodsFor: '*toc-tracking' stamp: 'OzC 4/8/2012 23:57'!
mthNames 
	^ self versions last mcVersion mthNames ! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 3/20/2012 12:44'!
forceUCatg
	self removeProperty: #ucatg ifAbsent:[].
	^ self uCatg 
	! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 3/19/2012 23:23'!
includesNode: aNode
	^ self start <= aNode start and: [aNode stop <= self stop]! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 3/22/2012 13:49'!
nextMsgParent 
	^ nil! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 3/19/2012 20:27'!
uCatg 
	^#()! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: ''!
with0Arg
	^ #metaObject
		run: #selector
		with: #()
		in: self! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: ''!
with1arg: v1 
^ #metaObject run: #selector with: {v1} in: self  ! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 4/10/2012 20:04'!
allProjectNames
	^ self projects inject: Set new into: [:set :pot | 
		pot isInTop1000 ifTrue:[set add: pot projectName].
		set] ! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 4/11/2012 18:25'!
classNamesTo: ls
	projects do: [:p |
		p versions last mcVersion classNamesTo: ls] displayingProgress: 'Collecting class names'! !

!EcoSystem methodsFor: '*toc-dynamic' stamp: 'OzC 7/27/2012 23:53'!
loadTOYProjects
	|toy names|
	toy:= TOYProjectDictionary new.
	names:= self projectNamesWithTests .
	self projects do: [:pot | 
		pot isInTop1000 ifTrue: [
			names do: [:pn| |toi|
				pot projectName = pn ifTrue: [
					toi := toy at: pn ifAbsentPut: [
						TOYProject new projectName: pn ;
										  markInstalled ;
										  yourself].
					toi addMCVersion: pot versions last mcVersion.
					]. 
		]]] displayingProgress: 'Loading TOYProjects'.
	^ toy! !

!EcoSystem methodsFor: '*toc-dynamic' stamp: 'OzC 8/6/2012 08:00'!
loadingOthersOn: toy 
	self projects do: [:pot | |pn| 
		"pot isInTop1000 ifTrue: ["
			pn:= pot projectName .
			(toy includesKey: pn) ifFalse:[ |toi| 
					toi :=toy at: pn ifAbsentPut: [
						TOYProject new projectName: pn ;
										  markInstalled ;
										  yourself].
					toi addMCVersion: pot versions last mcVersion.
			].
		"]"] displayingProgress: 'Loading TOYProjects'.
	^ toy! !

!EcoSystem methodsFor: '*toc-dynamic' stamp: 'OzC 7/25/2012 16:38'!
projectNamesWithTests
	|set|
	TOYProjectDictionary toyNames ifNotNilDo: [:v|  ^ v].
	set:= Set new.
	self projects do: [ :pot|
		((pot isInTop1000) and: [pot hasTestCase]) 
			ifTrue: [set add: pot projectName]] displayingProgress: 'Projects with Tests'.
	TOYProjectDictionary toyNames: set.	
	^ set! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 1/21/2012 15:10'!
retrieveAll
	|doc|
	doc:= self retrieveDeclarations.
	^ {doc . self retrieveAllUsagesWith: doc declarations}! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 4/10/2012 20:08'!
retrieveAllUsagesWith: dict
	dict loadFixedSelectors.
	projects do: [:p|
		p isInTop1000 ifTrue: [
			p versions last mcVersion findUsagesIn: dict.
			]
		] displayingProgress: 'Finding usages'.
	^ dict
	! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 4/10/2012 20:41'!
retrieveDeclarations
	|doc|
	doc:= TOProjectDictionary new.
	projects do: [:p| |dot name|
		p isInTop1000 ifTrue:[
			name := p projectName.
			dot := doc at: name ifAbsentPut: (TOProject new projectName: name).
			p versions last mcVersion loadDeclarationIn: dot.
			dot isEmpty 
				ifTrue: [doc removeKey: name] 
				ifFalse: [dot "loadClassNames ;" fixPredicates].
			].			
		] displayingProgress: 'Loading declarations'.
	^doc! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 3/7/2012 16:16'!
retrieveTypePredicates
	|doc|
	doc:= self retrieveDeclarations selectCategory: #isTypePredicate.
	^ {doc . self retrieveAllUsagesWith: doc declarations}! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 4/12/2012 11:05'!
selectorNames
	|ss|
	ss:= Set new.
	projects do: [:pot|
		ss addAll: (pot versions last mcVersion selectorNames)] displayingProgress: 'Collecting selectors'.
	^ ss! !

RBProgramNodeVisitor subclass: #TOCParseTreeMetricCalculator
	instanceVariableNames: 'methodComplexity numberOfMessageSends numberOfStatements numberOfLinesOfCode parameterComplexityMultiplier numberOfConditionals cyclomaticNumber booleanOperators cyclomaticNumber2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Metrics'!

!TOCParseTreeMetricCalculator commentStamp: '<historical>' prior: 0!
VisualWorksParseTreeMetricCalculator is a visitor computing AST based metrics. It also computes LOC. 
Right now only Number of MessageSends is computed in a correct manner.

Instance Variables:
	extendsSuper	<Boolean>	description of extendsSuper
	methodComplexity	<ArithmeticValue | CPointer>	description of methodComplexity
	numberOfLinesOfCode	<Magnitude | WindowSpec>	description of numberOfLinesOfCode
	numberOfMessageSends	<ArithmeticValue | CPointer>	description of numberOfMessageSends
	numberOfStatements	<ArithmeticValue | CPointer>	description of numberOfStatements
	parameterComplexityMultiplier	<Object>	description of parameterComplexityMultiplier

!

!TOCParseTreeMetricCalculator class methodsFor: 'as yet unclassified' stamp: 'OzC 9/14/2013 10:15'!
visitParsing: source
	^ self new visitNode: ([RBParser parseMethod: source] on: Error do: [:e | 
		RBParser parseMethod: 'notValidMethodFailToParse']).
	! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
acceptAssignmentNode: anAssignmentNode 
	
	super acceptAssignmentNode: anAssignmentNode.
	methodComplexity := methodComplexity + 0.5! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
acceptBlockNode: aBlockNode 
	
	super acceptBlockNode: aBlockNode.
	numberOfStatements := numberOfStatements + aBlockNode body size.! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
acceptCascadeNode: aCascadeNode 
	
	numberOfStatements := numberOfStatements + aCascadeNode messages size.
	^super acceptCascadeNode: aCascadeNode ! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: 'OzC 9/14/2013 10:20'!
acceptMessageNode: aMessageNode 
	
	| rcvr sel args |
	rcvr := aMessageNode receiver.
	sel := aMessageNode selector.
	args := aMessageNode arguments.
	super acceptMessageNode: aMessageNode.
	numberOfMessageSends := numberOfMessageSends + 1.
	self countConditionals: sel.
	self computeCyclomaticNumber: sel.	"sel = #printOn: 
		ifTrue: [self halt]."	"duplicated in VisualWorksAnnotator because we ay want to run them separately"
	"(self isSuperInMethod: sel withReceiver: rcvr)
		ifTrue: [self methodEntity propertyNamed: #cleanSuperSend put: true].
	(self isDirtySuperInMethod: sel withReceiver: rcvr)
		ifTrue: [self methodEntity propertyNamed: #dirtySuperSend put: true]."
	methodComplexity := sel isInfix
		ifTrue: [methodComplexity + 2]
		ifFalse:
			[sel numArgs > 1
				ifTrue: [methodComplexity + 3]
				ifFalse: [methodComplexity + 1]]	"(self isAPICall: sel) ifTrue: [
			methodComplexity + 5] ifFalse: [
		(self isPrimitiveCall: sel) ifTrue: [
			methodComplexity + 7] ifFalse: ["! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
acceptMethodNode: aMethodNode
	
	" I do not know where this block came from"
	"methodComplexity := methodComplexity + (0.3 * block arguments size)."

	self methodBodyOn: aMethodNode source readStream.
	^ super acceptMethodNode: aMethodNode! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
acceptSequenceNode: aSequenceNode 
	
	super acceptSequenceNode: aSequenceNode.
	numberOfStatements := numberOfStatements + aSequenceNode statements size.
	self methodComplexity: self methodComplexity + (0.5 * aSequenceNode temporaries size)! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: 'OzC 9/13/2013 21:37'!
computeCyclomaticNumber: sel
	"The following equations defined McCabe Cyclomatic Complexity:

	     1.The number of regions in a flow graph. 
     		2.V(G) = E - N + 2, where E are the edges and N are the nodes. 
     		3.V(G) = P + 1, where P are the predicate nodes. 

	The score is basically the number of decision points in a routine + 1. Decision points 
	are taken to be	conditionals and loops."
	
	| branches loops |
	branches := #(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue: #ifNil: #ifNil:ifNotNil: #ifNotNil:ifNil: #ifNotNil: #at:ifAbsent: #at:ifAbsentPut: #detect:ifNone: #on:do: #and: #or: #xor:).
	loops := #(#whileTrue: #whileTrue #whileFalse #whileFalse: #timesRepeat: #to:do: #do:separatedBy: #do: #collect: #select: #reject: #inject:into: #detect: #detect:ifNone: #anySatisfy: #allSatisfy: #piecesCutWhere:).	"-- please not that #detect:ifNone: is listed twice because it is both loop and branch!!!!!! -- akuhn"
	(branches includes: sel)
		ifTrue: [cyclomaticNumber2 := cyclomaticNumber2 + 1].
	(loops includes: sel) ifTrue: [cyclomaticNumber2 := cyclomaticNumber2 + 1].	
		
		"-- HERE STARTS THE OLD ERRORFUL IMPL --"
	(#(#or: #and: #xor: #& #|) includes: sel)
		ifTrue:
			[booleanOperators := booleanOperators + 1.
			^self].
	(#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue: #whileTrue #whileTrue: #whileFalse #whileFalse:)
		includes: sel)
		ifTrue:
			[| cyclo |
			cyclo := self cyclomaticNumber + 1 + booleanOperators.
			self cyclomaticNumber: cyclo.
			booleanOperators := 0].
	(#(#to:do: #timesRepeat:) includes: sel)
		ifTrue: [self cyclomaticNumber: self cyclomaticNumber + 1]! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
countConditionals: sel
	
	(#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue: #whileTrue #whileTrue: #whileFalse #whileFalse:)
		includes: sel)
		ifTrue: [self numberOfConditionals: self numberOfConditionals + 1]! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
cyclomaticNumber
	
	^cyclomaticNumber! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
cyclomaticNumber2
	
	^cyclomaticNumber2! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
cyclomaticNumber: anObject
	
	cyclomaticNumber := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self resetMetricValues! !

!TOCParseTreeMetricCalculator methodsFor: 'source access' stamp: ''!
methodBodyOn: aReadStream
	
	numberOfLinesOfCode := aReadStream contents occurrencesOf: Character cr.
	aReadStream contents last = Character cr
		ifFalse: [numberOfLinesOfCode := numberOfLinesOfCode + 1].	"the last line ay not contain a final cr"	"-- take care: some platforms use line-feeds instead of cr--"
	numberOfLinesOfCode == 1
		ifTrue:
			[| aux |
			aux := aReadStream contents occurrencesOf: Character lf.
			aReadStream contents last = Character cr
				ifFalse: [numberOfLinesOfCode := numberOfLinesOfCode + 1].
			numberOfLinesOfCode := numberOfLinesOfCode max: aux]! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
methodComplexity
	
	^methodComplexity! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
methodComplexity: anObject
	
	methodComplexity := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfConditionals
	
	^numberOfConditionals! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfConditionals: anObject
	
	numberOfConditionals := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfLinesOfCode
	
	^numberOfLinesOfCode! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfLinesOfCode: anObject
	
	numberOfLinesOfCode := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfMessageSends
	
	^numberOfMessageSends! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfMessageSends: anObject
	
	numberOfMessageSends := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfStatements
	
	^numberOfStatements! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
numberOfStatements: anObject
	
	numberOfStatements := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
parameterComplexityMultiplier
	
	^parameterComplexityMultiplier! !

!TOCParseTreeMetricCalculator methodsFor: 'accessing' stamp: ''!
parameterComplexityMultiplier: anObject
	
	parameterComplexityMultiplier := anObject! !

!TOCParseTreeMetricCalculator methodsFor: 'initialize-release' stamp: ''!
resetMetricValues
	
	self numberOfMessageSends: 0.
	self numberOfStatements: 0.
	self methodComplexity: 0.
	self parameterComplexityMultiplier: 0.
	self numberOfConditionals: 0.
	self cyclomaticNumber: 1.
	booleanOperators := 0.
	cyclomaticNumber2 := 1! !

!TOCParseTreeMetricCalculator methodsFor: 'enumerating' stamp: ''!
visitArgument: each
	
	methodComplexity := methodComplexity + parameterComplexityMultiplier.
	^super visitArgument: each! !

RBProgramNodeVisitor subclass: #TODeclarationVisitor
	instanceVariableNames: 'accepted mthDef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TODeclarationVisitor subclass: #TODAbstractSelectorVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODAbstractSelectorVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:58'!
acceptMessageNode: aMessageNode 
	((aMessageNode receiver isVariable) and: [aMessageNode receiver name = 'self']) ifTrue: [
		aMessageNode selector = #subclassResponsibility ifTrue: [
			accepted := true.
			^ self]].
	super acceptMessageNode: aMessageNode .
! !

TODeclarationVisitor subclass: #TODGetterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODGetterVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:35'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isVariable) and: [lit isLocallyBound not]) ifTrue: [accepted := true]! !

TODeclarationVisitor subclass: #TODTypePredicateVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypePredicateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:42'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isLiteralNode) and: [lit value isKindOf: Boolean]) ifTrue: [accepted := true]
	! !

TODeclarationVisitor subclass: #TODTypeStateVisitor
	instanceVariableNames: 'hasReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:35'!
acceptReturnNode: aReturnNode 
	hasReturn := true.
	super acceptReturnNode: aReturnNode .! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:24'!
acceptVariableNode: aVariableNode
	|name |
	name := aVariableNode name.
	(#(self super) includes: name) ifTrue: [ accepted := true. ^self.].
	
	"dependent on FEFI"
	aVariableNode  isLocallyBound ifFalse: [ accepted := true]
	
	 
	 ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:34'!
accepted 
	^ accepted & hasReturn ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:32'!
initialize 
	super initialize .
	hasReturn := false.! !

!TODeclarationVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:46'!
accept: def
	^ self new mthDef: def  ; 
		visitNode: (RBParser permissiveParseMethod: def source) ; 
		accepted
	 ! !

!TODeclarationVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 20:18'!
isEnable
	^ true! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
accepted 
	^ accepted ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
initialize 
	super initialize .
	accepted := false.! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:47'!
mthDef: cdef
	mthDef := cdef ! !

TODeclarationVisitor subclass: #TOFilterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TOFilterVisitor class
	instanceVariableNames: 'countFiltered'!

TOFilterVisitor class
	instanceVariableNames: 'countFiltered'!

TOFilterVisitor subclass: #TOFDoesNotUnderstandVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFDoesNotUnderstandVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:49'!
acceptMethodNode: aMethodNode 
	accepted :='doesNotUnderstand*' match: aMethodNode selector! !

TOFilterVisitor subclass: #TOFNonBoolVisitor
	instanceVariableNames: 'hasReturn avoid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:11'!
acceptMessageNode: aMessageNode
	
	aMessageNode selector = #subclassResponsibility ifTrue: [avoid := true . ^self].
	
	super acceptMessageNode: aMessageNode .! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:01'!
acceptReturnNode: aReturnNode 
	|node|
	hasReturn := true.
	node := aReturnNode value.
	node isLiteralNode ifTrue: [
		(node value isKindOf: Boolean) ifFalse: [accepted :=true]].
	((node isVariable) and: [#(self super) includes: node name]) ifTrue: [accepted := true]! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:11'!
accepted 
	^ avoid not and: [accepted | hasReturn not].! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:10'!
initialize 
	super initialize .
	hasReturn := false.
	avoid := false.! !

TOFilterVisitor subclass: #TOFNonLocalVisitor
	instanceVariableNames: 'firstVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonLocalVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 20:18'!
isEnable 
	^ false! !

!TOFNonLocalVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 23:23'!
acceptVariableNode: aVariableNode
	|cls|
	(aVariableNode isRead | aVariableNode isWrite) ifFalse: [^ self].
	firstVar ifFalse: [firstVar := accepted := true].
	(#(self super thisContext) includes: aVariableNode name) ifTrue: [accepted := false . ^ self].
	cls := mthDef clsDef.
	(aVariableNode isLocallyBound) ifFalse:[
		cls ifNotNil: [
			(cls hasInstanceVariable: aVariableNode name metaClass: mthDef classIsMeta)
				ifTrue: [accepted :=false. ^ self] ] 
			ifNil: [
			(aVariableNode name isClassName) 
				ifFalse: [ accepted := false. ^ self]]].
	
	
	  ! !

!TOFNonLocalVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 19:12'!
initialize 
	super initialize.
	firstVar := false.! !

!TOFilterVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 4/13/2012 10:57'!
canBeFiltered: def
	|flag|
	flag:= (self subclasses select: #isEnable) anySatisfy: [:filter | filter accept: def].
	flag ifTrue: [countFiltered := self countFiltered + 1].
	^ flag! !

!TOFilterVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 4/13/2012 10:55'!
countFiltered
	^ countFiltered ifNil: [countFiltered:=0]! !

TODeclarationVisitor subclass: #TOXState2TypeVisitor
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOXState2TypeVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:28'!
accept: def inProject: pjt
	^ self new mthDef: def  ; project: pjt ;
		visitNode: (RBParser permissiveParseMethod: def source) ; 
		accepted! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:23'!
acceptReturnNode: aReturnNode 
	|node|
	node := aReturnNode value.
	node isMessage ifFalse: [^ self].
	(node receiver isVariable and: [#(self super) includes: node receiver name]) ifFalse: [^ self].
	(self isTypePredicate: node selector) ifTrue: [accepted := true].! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:24'!
isTypePredicate: selector
	^ project hasTypePredicate: selector  ! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:23'!
project: pjt
	project := pjt.! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 9/14/2013 10:52'!
complexityMetrics
	"mth(avg): mthComplexity, numCond, cycloNum2"
	|visitor|
	visitor:= TOCParseTreeMetricCalculator visitParsing: self source.
	^ {visitor methodComplexity .  "per instruction: internal structure complexity"
		visitor numberOfConditionals .  "traditional conditions"
		visitor cyclomaticNumber2 }! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/22/2012 16:08'!
findUsagesIn: tod mcVersion: mc
	TOTrackingVisitor onDef: ( (self as: TOMCMethodDefinition) mcVersion: mc) 
					    find: tod 
						 
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
fullClassName2

	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [self className, ' class']! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 3/7/2012 13:24'!
loadDeclarationIn: toc mcVersion: mc
	|def clsDef|
	(toc matchSelector: self selector) ifFalse: [^self].
	def := ((self as: TOMCMethodDefinition) mcVersion: mc).
	(TOFilterVisitor canBeFiltered: def ) ifTrue: [^ self]. 
	toc addSelector: def. 
	
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
tocName 
	^ self fullClassName2 ,'>>',selector ! !

!TestCase class methodsFor: '*toc-fix' stamp: 'OzC 7/27/2012 01:06'!
sunitName
	^ self name! !

Dictionary subclass: #TODSelectorDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:54'!
addSelector: "(MCMthDef)" mthDef
	|selectors|
	selectors := self at: mthDef selector ifAbsentPut: [TODSelector new selector: mthDef selector].
	selectors implementors add: (TOSelector createFrom: mthDef) 
	! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:49'!
allValues
	^ self value inject: OrderedCollection new into: [:ls :tod | ls addAll: tod implementors ; yourself] ! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 21:33'!
hasTypePredicate: selector
	self at: selector ifAbsent: [^ false].
	^ (self at: selector) implementors allSatisfy: #isTypePredicate 
	! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:46'!
printString 
	^ (self size),'selectors'! !

Dictionary subclass: #TOProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 1/10/2012 22:36'!
allAbstracts
	^ self allCategory: #isAbstractSelector! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 1/10/2012 22:57'!
allCategories
	^ (self class allSelectorsInCategory: 'flat-selectors-category') collect: [:sel |
		sel -> (self perform: sel) size]! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 1/25/2012 21:56'!
allCategory: ctg
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors allValues select: ctg) ; yourself].! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allExtras
	^ self allCategory: #isExtra! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 17:27'!
allSelectors
	^ self values inject: OrderedCollection new into: [:ls :pot | 
		ls addAll: (pot selectors values) ; yourself 
		]! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:42'!
allStatePredicates
	^ self allCategory: #isStatePredicate! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allTypePredicates
	^ self allCategory: #isTypePredicate! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:55'!
allWithSource: source
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors allValues select: [:tos|
			source match: tos mthDef source]) ; yourself].! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:30'!
declarations 
	^ self values inject: TOSelectorDictionary new into: [:dec :pot | 
		dec addImplementors: pot selectors values]
	! !

!TOProjectDictionary methodsFor: 'flat-selectors-printing' stamp: 'OzC 3/26/2012 11:07'!
flatProjectClassPredicate
	|flat|
	flat := OrderedCollection newFrom: {{'Project' . 'Classes' . 'TPredicates'}}.
	(self values "sort: [:a :b | a selectors allValues size > b selectors allValues size] ; yourself") do: [:top |
		flat add: {top projectName . top classNames size . top selectors values size}].
	^ flat 
	
	! !

!TOProjectDictionary methodsFor: 'flat-selectors-printing' stamp: 'OzC 3/26/2012 11:06'!
flatProjectClassPredicate2
	|flat|
	flat := OrderedCollection newFrom: {{'Project' . 'Classes' . 'Predicate names' 
	. 'Predicates class' . 'Predicates instance'}}.
	(self values "sort: [:a :b | a selectors allValues size > b selectors allValues size] ; yourself") do: [:top |
		flat add: {top projectName . top classNames size . top selectors values size .
		(top selectors allValues select: [:f | f classIsMeta]) size . (top selectors allValues select: [:f | f classIsMeta not]) size}].
	^ flat 
	
	! !

!TOProjectDictionary methodsFor: 'flat-selectors-printing' stamp: 'OzC 4/12/2012 11:21'!
flatPurityRatio 
	^ self declarations flatPurityRatio ! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 23:51'!
printString 
	^ (self size asString ),'projects'! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 3/7/2012 15:52'!
selectCategory: ctg
	|this|
	this := self select: [:top | (top selectors allValues select: ctg) size > 0].
	"this keysAndValuesDo: [:k :pot | this at: k put: (pot selectCategory: #isTypePredicate)]."
	this values do: [:pot | pot selectCategory: ctg] displayingProgress: 'Selecting: ', ctg.
	^ this.! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 4/12/2012 10:56'!
selectorNamesInPCat: pCat
	|ss|
	ss:=Set new.
	self do: [:pot| 
		(pot isInPCat: pCat) ifTrue: [ ss addAll: (pot selectors values collect: #selector)]].
	^ss
	! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 17:23'!
selectorsMissingClassNames
	^ self values inject: OrderedCollection new into: [:ls :pot | 
		ls addAll: (pot selectors values select: #isMissingClassNames) ; yourself 
		]! !

Dictionary subclass: #TOSelectorDictionary
	instanceVariableNames: ''
	classVariableNames: 'cmdict'
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOSelectorDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 4/9/2012 00:26'!
clsAndMths
	^ cmdict! !

!TOSelectorDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 4/9/2012 00:15'!
clsAndMthsFrom: ecco
	cmdict := Dictionary new.
	ecco projects do: [:p | |pot|
		p isInTop1000 ifTrue:[ 
			pot:= cmdict at: p projectName ifAbsentPut: [{Set new . Set new}].
			pot first addAll: p classNames. 
			pot second addAll: p mthNames.
			]
		] displayingProgress: 'Collecting Cls/Meths'.
	^ cmdict
	! !

!TOSelectorDictionary methodsFor: 'adding' stamp: 'OzC 4/12/2012 14:35'!
addExistingImplementors: tos
	 |bucket|
	 bucket:= (self at: tos selector) implementors.
	 tos implementors do: [:i |
		(bucket includes: i) ifFalse: [bucket add: i]].! !

!TOSelectorDictionary methodsFor: 'adding' stamp: 'OzC 4/12/2012 12:34'!
addImplementors: toss
	toss do: [:tos| |flag|
		flag:=false.
		self at: tos selector ifAbsentPut: [flag:= true. tos as: TOTSelector].
		flag ifFalse: [ 
			 "self halt."
			 (self at: tos selector) implementors addAll: tos implementors ]]! !

!TOSelectorDictionary methodsFor: 'adding' stamp: 'OzC 4/12/2012 14:09'!
addImplementorsFrom: tod
	tod do: [ :to|
		to selectors do: [:tos|
			self addExistingImplementors: tos]
		]! !

!TOSelectorDictionary methodsFor: 'accessing' stamp: 'OzC 1/22/2012 16:00'!
all: ctg
	^ self values inject: OrderedCollection new into: [:ls :tos | ls addAll: (tos perform: ctg) ; yourself] ! !

!TOSelectorDictionary methodsFor: 'accessing' stamp: 'OzC 1/22/2012 16:00'!
allImplementors
	^ self all: #implementors! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 4/11/2012 12:48'!
allOnlyComplexUsages
	^ self allSenders select: #isAComplex! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 1/22/2012 16:01'!
allSenders
	^ self all: #senders! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 3/28/2012 12:19'!
allSendersInCtg: ctg
	^ self allSenders select: [:f | (f uCatg select: ctg) notEmpty]! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 3/26/2012 10:14'!
allUnCategorizedUsages
	^ self allSenders select: [:f | (f uCatg) isEmpty]! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 4/13/2012 18:19'!
avgMixed
	^ (self values select: [:f | f implementors notEmpty and: [(f purityRatio < 1) & (f purityRatio > 0)]] thenCollect: [:f | f purityRatio]) average ! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 4/13/2012 18:35'!
avgOf: sel
	^ (self values select: [:f | f implementors notEmpty and: [f perform: sel]] thenCollect: [:f | f implementors asSet size]) average! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 4/8/2012 23:31'!
classAndMethodsByProject
	|dict|
	dict:= Dictionary new.
	self allSenders do: [:f | |pot|
		pot := dict at: f senderProjectName ifAbsentPut: [ {Set new . Set new } ].
		pot first add: f mthDef fullClassName2 .
		pot second add: f mthDef tocName .  
		] displayingProgress: 'Collection Cls/Meths'.
	^ dict! !

!TOSelectorDictionary methodsFor: 'u-catg' stamp: 'OzC 4/11/2012 12:33'!
cleanUOverloads
	self allSenders do: #cleanUOverloads! !

!TOSelectorDictionary methodsFor: 'u-catg' stamp: 'OzC 4/11/2012 15:19'!
delDCategories
	self do: [:ton|
		ton senders removeAllSuchThat: [:f |f isAFlow not and: [f isAHighO not and: [f isATest not]]] 
		].
! !

!TOSelectorDictionary methodsFor: 'fixed-selectors' stamp: 'OzC 1/26/2012 10:08'!
fixedSelectors 
	^ self select: [:tos | (TOTFixedSelectors defaultSelectors)includes: tos selector].! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 3/25/2012 18:26'!
flatCategories
	|flat dict|
	flat := OrderedCollection newFrom: {{'Category' . 'sProjects' . 'usages'}}.
	dict:= Dictionary new.
	self do: [:tos |
		tos senders do: [:f |
			f uCatg do: [:ctg | |v|
				v:= (dict at: ctg ctgName ifAbsentPut: [{Set new . 0 }]) .
				v first add: f senderProjectName .
				v at: 2 put: 1 + v second.
				].
			].
		] displayingProgress: 'Collecting from Senders'.
	dict keysAndValuesDo: [:ctg :value |
		flat add: {ctg . value first size . value second }].
	^ flat.! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 4/11/2012 01:10'!
flatClsAndMths
	|dict c tc m tm|
	c:= m:= tc:= tm := 0.
	dict := self classAndMethodsByProject .
	dict keysAndValuesDo: [:k :v | |d|
		"d:= (cmdict at: k)."
		"tc:=tc + d  first size .    tm:= tm + d second size."
		c := c + v first size.      m:= m + v second size.
		].
	tc:= cmdict values inject: 0 into: [:acc :d | acc + d first size].
	tm:= cmdict values inject: 0 into: [:acc :d | acc + d second size]. 
	^ {c/tc asFloat . m/tm asFloat}	! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 4/2/2012 13:27'!
flatComplexByCtg
	|flat all|
	flat := OrderedCollection newFrom: {{'Category' . 'Complex'}}.
	all:= self allSenders select: #hasComplex thenCollect: #uCatg.
	(TOUCategory validCategories asOrderedCollection remove: TOUComplex ; yourself) do: [:ctg|
		|us|
		us:= all select: [:ar| (ar select: [:e| e isKindOf: ctg]) notEmpty].
		flat add: {ctg ctgName . us size }].
	"flat add: {'Alone' . all size }."
	^ flat! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 3/25/2012 18:07'!
flatGroupByProjects
	|flat dict|
	flat := OrderedCollection newFrom: {{'Group' . 'sProjects' }}.
	dict:= Dictionary new.
	self do: [:tos | 
		(dict at: tos group ifAbsentPut: [Set new]) addAll: tos sProjectNames. 
		].
	dict keysAndValuesDo: [:group :set |
		flat add: {group . set size}].
	^ flat.! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 4/12/2012 14:50'!
flatPurityRatio
	|dict|
	dict:=( (1 to: 22) collect: [:f | 0]) asOrderedCollection . 
	
	self do:[:tos|
		tos implementors notEmpty ifTrue: [ |r i|
			r:= tos purityRatio.
			i:=1 + (r*20) asInteger.
			r isZero ifTrue: [i:=22].
			dict at: i put: (1 + (dict at: i))
			].
		]  displayingProgress: 'Collecting ratio'.
	

	^ dict "later a flat"! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 4/12/2012 14:59'!
flatPurityUsages
	|ls|
	ls:=OrderedCollection new . 
	
	self do:[:tos|
		tos implementors notEmpty ifTrue: [
			ls add: {tos purityRatio asFloat . tos senders size}
			].
		]  displayingProgress: 'Collecting ratio'.
	

	^ ls "later a flat"! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 3/8/2012 09:39'!
flatTopSenders
	|flat|
	flat := OrderedCollection newFrom: {{'Selector' . 'iProjects' .'sProjects' . 'OverUsed?' . 'Senders'}}.
	self topSenders do: [:tos | flat add: {tos selector . 
		tos iProjectNames size . 
		tos sProjectNames size . 
		tos isOverUsed . 
		tos senders size}].
	^ flat.! !

!TOSelectorDictionary methodsFor: 'flat-queries-printing' stamp: 'OzC 3/20/2012 13:16'!
flatUCategories
	|flat|
	flat := OrderedCollection newFrom: {{'Selector' . 'Usages' . 'Flow' . 'Logical' . 'HighOrder' . 'Forward'. 'Test' . 'Others'}}.
	self topSenders do: [:tos | flat add: {tos selector . tos senders size . 
		(tos senders select: [:f | (f uCatg select: #isFlow) notEmpty]) size . 
		(tos senders select: [:f | (f uCatg select: #isComplex) notEmpty]) size . 
		(tos senders select: [:f | (f uCatg select: #isHighOrder) notEmpty]) size .
		(tos senders select: [:f | (f uCatg select: #isForward) notEmpty]) size . 
		(tos senders select: [:f | (f uCatg select: #isTest) notEmpty]) size .
		(tos senders select: [:f | (f uCatg) isEmpty]) size}].
	^ flat! !

!TOSelectorDictionary methodsFor: 'u-catg' stamp: 'OzC 4/11/2012 12:36'!
forceUCatg 
	self allSenders do: [:f | f expr forceUCatg]! !

!TOSelectorDictionary methodsFor: 'fixed-selectors' stamp: 'OzC 3/20/2012 01:26'!
loadFixedSelectors 
	(TOTFixedSelectors subclasses select: #isActive)  do: [:fClass | |sd|
		sd:=self at: fClass defaultSelector  
			 ifAbsentPut: [TOTFixSelector new selector: fClass defaultSelector  ; fClass: fClass].
		sd isFixSelector ifFalse: [sd becomeForward: ((sd as: TOTFixSelector) fClass: fClass)]]! !

!TOSelectorDictionary methodsFor: 'split' stamp: 'OzC 3/26/2012 10:10'!
selectGroup: grp
	^ self select: [:tos | tos group = grp]! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 3/25/2012 18:03'!
sendersReGroup
	self do: [:tos | 
		tos group: (tos isFixSelector ifTrue: [tos fClass group] ifFalse: [#poly]).
		] "displayingProgress: 'Regrouping'"! !

!TOSelectorDictionary methodsFor: 'queries' stamp: 'OzC 3/14/2012 11:00'!
topSenders
	^ self "copy" values sort: [:a :b | a senders size >= b senders size]
	! !

Dictionary subclass: #TOYProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

TOYProjectDictionary class
	instanceVariableNames: 'toyNames validInstance'!

TOYProjectDictionary class
	instanceVariableNames: 'toyNames validInstance'!

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 11:35'!
currentState
	^ (FileStream readOnlyFileNamed: 'current.toy') contents trimBoth.
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 09:31'!
preLoadNext
	|pn|
	pn:= self currentState.
	(self validInstance at: pn) preLoad. 
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/4/2012 09:19'!
preLoadScript
	self error: 'Must not be executed directly'.
	[ TOYProjectDictionary preLoadNext ] ensure: [ Smalltalk quitPrimitive ]
	
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 09:25'!
recordState: state
	FileStream forceNewFileNamed: 'current.toy' do: [:stream| 
		stream nextPutAll: state].
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 20:22'!
runNext
	|pn|
	pn:= self currentState.
	TOYSProject runningInstance: (FLMaterializer materializeFromFileNamed: 'fuels/' , pn ,'.fuel').
	TOYSProject runningInstance run.
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/7/2012 13:38'!
runScript
	self error: 'Must not be executed directly'.
	[ TOYProjectDictionary runNext ] ensure: [ Smalltalk quitPrimitive ]
	
	! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 7/25/2012 16:34'!
toyNames
	^ toyNames! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 7/25/2012 16:34'!
toyNames: list
  toyNames := list! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 08:01'!
validInstance
	^ validInstance! !

!TOYProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 08:01'!
validInstance: inst
	validInstance := inst! !

!TOYProjectDictionary methodsFor: 'converting' stamp: 'OzC 2/4/2013 01:04'!
asOrderedCollection: sortBlock
	^ self values sort: sortBlock! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 12:14'!
cleanReferences
	self do: [:poy| poy isRunnable ifTrue:[poy dependencyCache cleanReferences]]! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 09:06'!
clsNamesDependencies
	|clsNames|
	clsNames := self missingClsNames.
	self do: [:poy|
		 poy mcVersions do: [:mcv|
			mcv snapshot definitions do: [:def|
				(def isPureClsDef) ifTrue: [
					clsNames at: def className ifPresent:[:ss| ss add: poy]]]
			] "displayingProgress: 'in ',poy projectName"
		] "displayingProgress: 'checking dependencies'" .
	^ clsNames! !

!TOYProjectDictionary methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 19:04'!
collectData: source
	|ls|
	ls := OrderedCollection new.
	self values do: [:top| ls add: (top perform: source)]displayingProgress: 'collecting static data'.
	^ ls! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 07:52'!
fromLine: line withDependencies: depCache
	|tokens poy errors|
	tokens := line findTokens: ','.
	poy := self at: tokens second trimBoth.
	poy runnableState: tokens first trimBoth.
	poy dependencyCache: depCache filterDuplicates.
	
	errors :=  tokens fourth findTokens: '.'.
	errors removeFirst.
	poy msgErrors removeAll.
	errors do: [:err| poy addError: err trimBoth].
	
	^ poy
	
	
	
	
	
	! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/5/2012 00:33'!
loadMissingDependencies
	|dirName cache|
	dirName:= 'general-log/'.
	cache := TOYDependencyCache new.
	(FileDirectory on: (Smalltalk imagePath),'/', dirName) entries do: [:de|
		(de readStream contents findTokens: Character cr) do: [:line| |dep|
			dep:= (TOYDependency loadFromLine: line).
			dep ifNil: [ 
				self fromLine: line withDependencies: cache.
				cache := TOYDependencyCache new. ] ifNotNil: [ cache addDependency: dep] 
			] displayingProgress: 'file: ', de name
		] displayingProgress: 'reading files on: ',dirName
	
	
	
	! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 12:17'!
loadReferences
	|clsNames|
	clsNames:= self clsNamesDependencies.
	self do: [:poy|
		poy isRunnable ifTrue: [
			poy dependencyCache loadPkgRefsFrom: self ;
									loadClsRefsFrom: clsNames.
			
			]] displayingProgress: 'loading references'! !

!TOYProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 7/26/2012 07:32'!
markInstalled
	self do: [:poi|
		poi markInstalled]! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 08:42'!
missingClsNames
	^ self values inject: Dictionary new into: [:dict :toy|
		toy isRunnable ifTrue:[toy dependencyCache dependencies do: [:dep|
			(dep isDepMCClass or: [dep isDepWRClass]) ifTrue: [ 
				dep clsNames do: [:cn| dict at: cn put: Set new]]]].
		dict]! !

!TOYProjectDictionary methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 08:20'!
missingDepNames
	^ self values inject: Dictionary new into: [:dict :toy|
		toy isRunnable ifTrue: [toy dependencyCache dependencies do: [:dep|
			(dep isDepMCPackage) ifTrue: [ 
				dict at: dep pkgName put: [Set new] ]]].
		dict]! !

!TOYProjectDictionary methodsFor: 'run-and-load' stamp: 'OzC 8/2/2012 07:23'!
preRun
	|list|
	list := (self values select: [:toi | toi projectName > '..']) asSortedCollection.
	list do: #preRun displayingProgress: 'Loading Projects'! !

!TOYProjectDictionary methodsFor: 'run-and-load' stamp: 'OzC 8/2/2012 16:40'!
preRunIndependently
	|list|
	list := (self values select: [:toi | toi projectName >= 'Testing']) asSortedCollection.
	list do: [:poy|
		self class recordState: poy projectName.
		"self halt."
		TOYScript defaultPreLoad runAndBlock.
		] displayingProgress: 'Pre-running Projects'! !

!TOYProjectDictionary methodsFor: 'printing' stamp: 'OzC 7/25/2012 16:52'!
printString
	^ 'TOYDict: ',(self size asString),'projects'! !

!TOYProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 08:09'!
recordSerializableProjects
	|list|
	list := (self values select: [:toi | toi isRunnable and: [toi projectName >= '..']]) asSortedCollection.
	list do: [:poy|
		(poy serializableProject) serialize.
		] displayingProgress: 'Recording Projects'! !

!TOYProjectDictionary methodsFor: 'run-and-load' stamp: 'OzC 7/27/2012 01:10'!
run
	|list|
	list := (self values select: [:toi | toi projectName > 'BinaryStreamTools']) asSortedCollection.
	list do: #run displayingProgress: 'Running tests on Projects'! !

!TOYProjectDictionary methodsFor: 'run-and-load' stamp: 'OzC 2/4/2013 10:57'!
runIndependently
	|list|
	list := (self values select: [:toi | TOYProject testProjects includesKey: toi projectName]) asSortedCollection.
	list do: [:poy| |filePath|
		filePath:= ('fuels/' , poy projectName , '.fuel').
		(FileStream isAFileNamed: filePath) ifFalse: [FLSerializer serialize: (poy serializableProject) toFileNamed: filePath . ]. 
		self class recordState: poy projectName.
		"self halt."
		TOYScript defaultPharo1 runAndBlock.
		] displayingProgress: 'Running Projects'! !

!TOYProjectDictionary methodsFor: 'run-and-load' stamp: 'OzC 12/3/2012 17:53'!
runIndependentlyFromDisk
	|list|
	list := (self values select: [:f | 
			     f isRunnable and: [
			    (f flatReferences size >= 10) and: [ ", done < 10"
			    (f testsCount > 20)]]	 "  ,done >20"	
		]) asSortedCollection.
	list:= list reject: [:f | #(AudioVideoLib BFAV Blackjack(21) Jihachol Network OB RenderMouse) includes: f projectName ].
	(list select: [:f | f projectName >= 'Chuck'] ) do: [:poy|
		"FLSerializer serialize: (poy serializableProject) toFileNamed: ('fuels/' , poy projectName , '.fuel').  "
		self class recordState: poy projectName.
		"self halt."
		TOYScript defaultPharo1 runAndBlock.
		] displayingProgress: 'Running Projects'! !

!TOYProjectDictionary methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 19:07'!
staticBasicMetrics
	^ self collectData: #genInfoMetrics! !

!TOYProjectDictionary methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 19:05'!
staticTestData
	^ self collectData: #staticTestData! !

Dictionary subclass: #TOYRProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRProjectDictionary class methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 18:25'!
loadFromDir: dirName
	|cg cps dict ces | 
	cps := OrderedCollection new.
	ces := OrderedCollection new.
	dict:= self new.
	((FileDirectory on: (Smalltalk imagePath),'/', dirName) entries reject: [:de| '.*' match: de name]) do: [:de|
		(de readStream contents findTokens: Character cr) do: [:line| |dep|
			
			dep:= (TOYRData loadFromLine: line).
			dep ifNil: [ 
					ces add: (TOYRError new msg: (line findTokens: ':') second)]
				ifNotNil: [ 
					dep isRProject ifTrue: [ 
						self assert: (dict includesKey: dep projectName) not.
						cg ifNotNil: [dep global: cg].
						cps isEmpty ifFalse: [dep predicates addAll: cps].
						ces isEmpty ifFalse: [dep emsg: ces asCommaString withoutQuoting].
						dict at: dep projectName ifAbsentPut: [dep ].
						cg:= nil. cps:= OrderedCollection new . ces:=OrderedCollection new].
					dep isRGlobal ifTrue: [cg:=dep].
					dep isRPredicate  ifTrue: [cps add: dep].
						] 
			
			] displayingProgress: 'file: ', de name.
		cg:= nil. cps:= OrderedCollection new . ces:=OrderedCollection new.
		] displayingProgress: 'reading files on: ',dirName.
	^ dict! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 22:15'!
filterPredicatesWithLessCoverage: coverage
	|neo|
	neo := self select: #hasValidPredicates.
      neo keysAndValuesDo: [:k :v | 
		neo at: k  put: (v filterPredicatesWithLessCoverage: coverage) ].		

        ^ neo! !

!TOYRProjectDictionary methodsFor: 'purity' stamp: 'OzC 8/16/2012 01:29'!
impurePredicateNames
	^ self selectPredicateNames: #isImpure
	
	
	
	! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:24'!
passedTests
	^ self values inject: 0 into: [:acc :pred | pred global ifNil: [acc] ifNotNilDo:[:g| acc + g unitPassedCount ]] ! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 17:45'!
predicateDidExecuted
	^ (self select: #hasValidPredicates) values inject: OrderedCollection new into:[:ls :pred| ls addAll: (pred predicates select: #hasBeenExecuted); yourself ] ! !

!TOYRProjectDictionary methodsFor: 'purity' stamp: 'OzC 8/16/2012 01:27'!
predicateNames
	^ self values inject: OrderedCollection new
		 into: [:os :po| os addAll: (po predicateNames ) ; yourself]
	
	
	
	! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/14/2012 17:30'!
predicateNamesWithCoverage: n
	|ls|
	ls := OrderedCollection new.
	(self select: #hasValidPredicates) predicatesCoverage valuesDo: [:dict|
		dict keysAndValuesDo:  [:k :v | 
			(v>= n) ifTrue: [ ls add: k ]]].
	^ ls! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:23'!
predicates 
	^ self values 
		inject: OrderedCollection new 
		into: [:os :po | 
			po hasPredicates ifTrue: [os addAll: po predicates].
			os]! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 17:56'!
predicatesCoverage
	|dict|
	dict := self class new.
	self keysAndValuesDo: [:k :v |
		dict at: k put: v predicatesCoverage .
		].
	^ dict! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 22:01'!
predicatesWithCoverage: n
	|ns|
	ns:= self predicateNamesWithCoverage: n.
	
    ^ self predicateDidExecuted select: [:pred| ns includes: pred selector   ]! !

!TOYRProjectDictionary methodsFor: 'purity' stamp: 'OzC 8/16/2012 01:29'!
purePredicateNames
	^ self selectPredicateNames: #isPure
	
	
	
	! !

!TOYRProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 17:46'!
runnedTests
	^ self values inject: 0 into: [:acc :pred | pred global ifNil: [acc] ifNotNilDo:[:g| acc + g unitRunCount ]] ! !

!TOYRProjectDictionary methodsFor: 'purity' stamp: 'OzC 8/16/2012 01:38'!
selectPredicateNames: condition 
	^ self values inject: OrderedCollection new
		 into: [:os :po| 
			os addAll: ((po selectPredicateNames: condition) collect: [:sel| po projectName , '>>' , sel]) ; yourself]
	
	
	
	! !

!Object methodsFor: '*toc-kernel-override' stamp: 'OzC 8/9/2012 20:56'!
primitiveError: aString 
	"This method is called when the error handling results in a recursion in 
	calling on error: or halt or halt:."
	self flag: #toy.
	TOYSProject runningInstance emergencyQuit.
	
	UIManager default onPrimitiveError: aString.! !

Object subclass: #TODSelector
	instanceVariableNames: 'selector implementors iclassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 17:46'!
addClassNamesFrom: ecco
	self isMissingClassNames ifTrue: [
		ecco projects do: [:pjt | 
			self setClassNamesFrom: pjt versions last mcVersion] displayingProgress: self asString 
		]! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 4/11/2012 18:12'!
iclassNames
	^ iclassNames ifNil: [|mcVersion|
		mcVersion := nil.
		implementors do: [:im|
			mcVersion ~= im mthDef mcVersion ifTrue: [
				mcVersion := im mthDef mcVersion.
				self setClassNamesFrom:  mcVersion .	
				].
			]
		].! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
implementors
	^ implementors! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:42'!
initialize 
	super initialize .
	implementors := SortedCollection new.! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 17:24'!
isMissingClassNames
	^ self iclassNames isEmpty ! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 21:07'!
printString 
	"^ selector ,'  ',implementors size asString ,'impl.'"
	|name|
	name := selector ,' ',(implementors  size asString),'#'.
	(implementors  size) > 0 ifTrue:  [
		{#isTypePredicate -> 'type' . #isStatePredicate->'state' . #isAbstractSelector -> 'abstr' . #isExtra -> 'extra'} do: [:pair|
			name := name, ', ',(implementors select: pair key) size asString,(pair value)]].
	^ name! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 17:33'!
removeCaches
	iclassNames := nil! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/7/2012 15:37'!
selectCategory: ctg
	implementors := implementors select: ctg.
	iclassNames := nil.
	self iclassNames .
	! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
selector
	^ selector! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
selector: anObject
	selector := anObject! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 4/11/2012 17:41'!
setClassNamesFrom: mcVersion
	iclassNames := mcVersion classPartiallyNamed: selector todPropertyName 
								     			withSelector: selector! !

TODSelector subclass: #TOTSelector
	instanceVariableNames: 'senders hidden group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

TOTSelector subclass: #TOTFixSelector
	instanceVariableNames: 'fClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/28/2012 16:38'!
acceptLiteralSelector: sel 
	^ fClass acceptLiteralSelector: sel ! !

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:53'!
acceptSelector: node 
	^ fClass acceptSelector: node ! !

!TOTFixSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 10:04'!
fClass
	^ fClass! !

!TOTFixSelector methodsFor: 'accessing' stamp: 'OzC 3/25/2012 17:38'!
fClass: class
	self group: class group .
	fClass := class! !

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:12'!
isFixSelector 
	^ true! !

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 10:27'!
isHidden 
	^ false.! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/28/2012 16:38'!
acceptLiteralSelector: sel 
	self isHidden ifTrue: [^ false]. 
	^ selector = sel   ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 10:24'!
acceptSelector: node 
	self isHidden ifTrue: [^ false]. 
	^ selector = node selector   ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 13:09'!
allUCatg
	^ self senders collect: #uCatg! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 3/25/2012 17:03'!
group 
	^ group ! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 3/25/2012 17:03'!
group: kind 
	group := kind! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 15:57'!
iProjectNames
	^ implementors inject: Set new into: [:set :tos | set add: tos projectName  ; yourself] ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 17:39'!
initialize 
	super initialize .
	senders := SortedCollection new. "FDataDef".
	group := #poly! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:12'!
isFixSelector
	^ false! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 3/20/2012 10:26'!
isHidden 
	^ hidden ifNil: [hidden:= TOTFixedSelectors fixedSelectors includes: self selector]! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/13/2012 18:23'!
isImpure
	^ self purityRatio isZero ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/13/2012 18:25'!
isMix
	^ (self isPure not) and: [self isImpure not]! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/22/2012 22:53'!
isOverUsed
	^ self iProjectNames size < self sProjectNames size! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/13/2012 18:23'!
isPure
	^ self purityRatio  == 1! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/22/2012 22:29'!
isSingle
	|ip|
	ip:= self iProjectNames .
	^ ip size = 1 and: [ip = self sProjectNames ]! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:43'!
printString 
	^ super printString,' ' ,senders size asString,'send'! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/12/2012 14:50'!
purityRatio
	"self implementors isEmptyOrNil ifTrue: [^ -1]."
	^ (self implementors select: #isTypePredicate) size / self implementors size.! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 16:07'!
sProjectNames
	^ senders inject: Set new into: [:set :tos | set add: tos senderProjectName  ; yourself] ! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 08:40'!
senders
	^ senders ifNil: [senders := SortedCollection new.]! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/9/2012 10:53'!
sendersByProjectCategory
		|  bodyDict|
	
		bodyDict := Dictionary newFrom: (FSource pkgCategories collect: [:ctg | ctg -> 0]).	
		senders  do: [ :fs |  fs countOnPkgCtg: bodyDict].
		 ^ bodyDict . ! !

Object subclass: #TOProject
	instanceVariableNames: 'projectName selectors cachedClss cachedMths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 1/25/2012 09:39'!
matchSelector: selector
	self selectorPatterns do:[:patt|  |idx|
		idx := patt size + 1.
		(((patt , '#*') match: selector) and: [
			((selector at: idx) isUppercase & ( (selector last) ~= $: ))]) ifTrue: [^ true]
		].
	^ false
! !

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 4/10/2012 20:30'!
selectorPatterns
	^#(is "has does should shall can could may maybe might would will not if")! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:34'!
addSelector: "(MCMthDef)" mthDef
	selectors addSelector: mthDef
	! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 4/8/2012 18:46'!
classNames
	^ cachedClss ifNil:[
		cachedClss := selectors allValues inject: Set new into: [:ls :tod |
		 ls addAll: tod classNames ; yourself.
		] 
	]! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 4/8/2012 18:47'!
delCaches
	cachedClss := nil.
	cachedMths := nil.! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 21:28'!
fixPredicates
	 selectors do: [:tod|
			(tod implementors select: [:tos | tos isStatePredicate 
				and: [TOXState2TypeVisitor accept: tos mthDef inProject: self]]) do:[:to|
				"self halt."
				tod implementors remove: to;
						add: ((to as: TOTypePredicateSelector) isNative: false).
				]
			]! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:35'!
hasTypePredicate: selector
	^ selectors hasTypePredicate: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:31'!
initialize 
	selectors := TODSelectorDictionary new.! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 12:59'!
isEmpty
	^ selectors size == 0! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 4/12/2012 10:58'!
isInPCat: pCat
	^ (FSource cachedPkgCtg at: projectName) = pCat
	! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:22'!
loadClassNames 
	selectors do: #iclassNames! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:58'!
matchSelector: selector
	^ self class matchSelector: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 4/8/2012 18:46'!
mthNames
	^ cachedMths ifNil: [
		cachedMths := selectors allValues inject: Set new into: [:ls :tod |
		 ls addAll: tod mthNames ; yourself.
		]
	] ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:47'!
printString 
	|name|
	name := projectName,' ',(selectors size asString),'#'.
	(selectors size) > 0 ifTrue:  [
		{#isTypePredicate -> 'type' . #isStatePredicate->'state' . #isAbstractSelector -> 'abstr' . #isExtra -> 'extra'} do: [:pair|
			name := name, ', ',(selectors allValues select: pair key) size asString,(pair value)]].
	^ name! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName
	^ projectName! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName: anObject
	projectName := anObject! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 3/7/2012 15:42'!
selectCategory: ctg
	selectors := selectors select: [:tod | (tod implementors  select: ctg) size > 0].
	selectors valuesDo: [:to | to selectCategory: ctg].	! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
selectors
	^ selectors! !

Object subclass: #TOSelector
	instanceVariableNames: 'mthDef validated unvalidated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOSelector subclass: #TOAbstractSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
shortName 
	^ 'Abstract'! !

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
visitorClass 
	^ TODAbstractSelectorVisitor! !

!TOAbstractSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ true! !

TOSelector subclass: #TOExtraSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOExtraSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Extra'! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isExtra
	^true! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:10'!
validate: def
	self class visitorClasses do: [:tot|
		(tot visitorClass accept: def) 
			ifTrue: [self unvalidated add: def. ^self]].
	self validated add: def.! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:49'!
createFrom: mthDef
	"order define precendece"
	self visitorClasses do: [:tot|
		(tot visitorClass accept: mthDef) ifTrue: [^ tot new mthDef: mthDef] ].
	^ TOExtraSelector new mthDef: mthDef  ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ self subclassResponsibility ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:31'!
visitorClasses
	^
	"order define precendece"
	{TOAbstractSelector . TOGetterSelector . TOStatePredicateSelector . TOTypePredicateSelector} ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:41'!
<= another
	self selector  = another selector ifFalse: [^ self selector <= another selector].
	^ self mthDef tocName <= another mthDef tocName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 3/26/2012 11:00'!
classIsMeta
	^ mthDef classIsMeta ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/8/2012 23:51'!
classNames 
	^ mthDef mcVersion classNames! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:36'!
duplicatesLength
	|n|
	n:= validated ifNil: [0] ifNotNil: [validated size]. 
	n:= n + (unvalidated ifNil: [0] ifNotNil: [unvalidated size]). 
	^ n! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isExtra
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 1/18/2012 11:36'!
isGetter
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isTypePredicate
	^false! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/16/2011 20:05'!
mthDef
	^ mthDef! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:07'!
mthDef: def
	mthDef := def! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/8/2012 23:53'!
mthNames 
	^ mthDef mcVersion mthNames  ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:19'!
pattern
	^ mthDef selector todPattern ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 11:30'!
printString 
	^ self class shortName, '[',mthDef tocName,']'! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 15:57'!
projectName 
	^ mthDef projectName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:20'!
propertyName
	^mthDef selector todPropertyName ! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:06'!
selector
	^ mthDef selector! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
unvalidated 
	^ unvalidated ifNil: [unvalidated := Set new.]! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:03'!
validate: def
	((self class visitorClass accept: def) 
		ifTrue: [self validated] ifFalse:[ self unvalidated]) add: def! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
validated 
	^ validated ifNil: [validated := Set new.]! !

TOSelector subclass: #TOStatePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOStatePredicateSelector subclass: #TOGetterSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:39'!
shortName 
	^ 'Getter'! !

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:40'!
visitorClass 
	^ TODGetterVisitor! !

!TOGetterSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:36'!
isGetter 
	^ true! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:33'!
shortName 
	^ 'State'! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypeStateVisitor! !

!TOStatePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate  
	^ true! !

TOSelector subclass: #TOTypePredicateSelector
	instanceVariableNames: 'isNative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Type'! !

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypePredicateVisitor! !

!TOTypePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 20:37'!
initialize 
	super initialize .
	isNative := true.! !

!TOTypePredicateSelector methodsFor: 'accessing' stamp: 'OzC 4/10/2012 20:37'!
isNative
	^ isNative! !

!TOTypePredicateSelector methodsFor: 'accessing' stamp: 'OzC 4/10/2012 20:37'!
isNative: anObject
	isNative := anObject! !

!TOTypePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isTypePredicate 
	^true! !

Object subclass: #TOTFixedSelectors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

TOTFixedSelectors subclass: #TOTEmptyFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:58'!
defaultSelector 
	^ #isEmpty! !

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 14:45'!
fSelectors 
	^ #( #isEmpty #notEmpty #isEmptyOrNil)! !

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 15:27'!
group 
	^ #empty! !

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:11'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == 0]) and: [b isMessage and: [b selector == #size]]]
	! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:13'!
acceptAlternative: node
 	(self alternativeSelectors includes: node selector) ifFalse: [^ false] .
	^ (self patternBlock value: node receiver value: node arguments first) 
	or: [self patternBlock value: node arguments first value: node receiver] ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 3/28/2012 16:39'!
acceptLiteralSelector: sel
	^ self fSelectors includes: sel ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:27'!
acceptSelector: node
	^ (self fSelectors includes: node selector) or: [
		self acceptAlternative: node]  ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:01'!
alternativeSelectors
	^#(#= #== #~=)! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:48'!
defaultSelector
	^ self subclassResponsibility ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:54'!
defaultSelectors
	^ self subclasses inject: OrderedCollection new into: [:ls :cls | 
		cls isActive ifTrue:[ls add: cls defaultSelector] . ls]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 10:29'!
fSelectors
	^ self subclassResponsibility ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:55'!
fixedSelectors
	^ self subclasses inject: OrderedCollection new into: [:ls :cls | 
		cls isActive ifTrue:[ls addAll: cls fSelectors] . ls]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 17:40'!
group 
	^ self subclassResponsibility ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:57'!
isActive 
	^ true ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:18'!
patternBlock 
	^ [:a :b | false]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:28'!
shortName
	^ self subclassResponsibility ! !

TOTFixedSelectors subclass: #TOTKindOfFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:49'!
defaultSelector 
	^ #isKindOf:! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:20'!
fSelectors
	^  #(#isKindOf: #isMemberOf:)! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 17:40'!
group 
	^ #nominal! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:16'!
patternBlock
	^ [:a :b | (a isVariable and: [a name isClassName]) or: [b isMessage and: [b selector == #class]]]! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'kindOf'! !

TOTFixedSelectors subclass: #TOTNilFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:49'!
defaultSelector 
	^ #isNil! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/31/2012 13:04'!
fSelectors
	^  #(haltIfNil ifNil: ifNil:ifNotNilDo: ifNil:ifNotNil: ifNotNilDo: ifNotNilDo:ifNil: ifNotNil: ifNotNil:ifNil:  isNil notNil)! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 15:28'!
group 
	^ #nilf! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:17'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == nil])]! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'nil'! !

TOTFixedSelectors subclass: #TOTStructuralCheckFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:50'!
defaultSelector 
	^ #respondsTo:! !

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/31/2012 13:04'!
fSelectors 
	^#(respondsTo: canUnderstand:)! !

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 17:41'!
group 
	^ #struct! !

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'structural'! !

TOTFixedSelectors subclass: #TOTZeroFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:59'!
defaultSelector 
	^ #isZero! !

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/31/2012 13:04'!
fSelectors 
	^ #( isZero notZero)! !

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 15:28'!
group 
	^ #zero! !

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:18'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == 0])]! !

Object subclass: #TOUCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUCategory class methodsFor: 'selectors' stamp: 'OzC 3/19/2012 23:58'!
argumentSelectors
	^ #()! !

!TOUCategory class methodsFor: 'selectors' stamp: 'OzC 3/19/2012 23:59'!
bothSelectors
	^ #()! !

!TOUCategory class methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 19:04'!
categorize: expr
	^(self validCategories 
			collect: [:cls | cls categoryOf: expr]) select: #notNil! !

!TOUCategory class methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 18:59'!
categoryOf: expr
	|catg|
	catg := self new.
	(catg doesItComply: expr) ifFalse: [^ nil].
	^catg! !

!TOUCategory class methodsFor: 'as yet unclassified' stamp: 'OzC 3/25/2012 19:14'!
ctgName 
	|nname|
	nname:= self name.
	^ nname copyFrom: 4 to: (nname size) 
	! !

!TOUCategory class methodsFor: 'selectors' stamp: 'OzC 3/19/2012 23:58'!
receiverSelectors
	^ #()! !

!TOUCategory class methodsFor: 'selectors' stamp: 'OzC 3/19/2012 23:54'!
trackedSelectors
	^ (self argumentSelectors union: self receiverSelectors) union: self bothSelectors ! !

!TOUCategory class methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 19:52'!
validCategories
	^ {TOUFlow . TOUForward . TOUComplex . TOUTest . TOUHighOrder ". TOUEqMethods" } ! !

!TOUCategory methodsFor: 'accessing' stamp: 'OzC 3/25/2012 19:14'!
ctgName
	^ self class ctgName ! !

!TOUCategory methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 19:11'!
doesItComply: expr
	^ self subclassResponsibility.! !

!TOUCategory methodsFor: 'testing' stamp: 'OzC 3/19/2012 12:56'!
isComplex
	^ false! !

!TOUCategory methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 19:38'!
isEqMethod 
	^ false! !

!TOUCategory methodsFor: 'testing' stamp: 'OzC 3/19/2012 12:56'!
isFlow
	^ false! !

!TOUCategory methodsFor: 'testing' stamp: 'OzC 3/19/2012 12:56'!
isForward
	^ false! !

!TOUCategory methodsFor: 'testing' stamp: 'OzC 3/19/2012 12:57'!
isHighOrder
	^ false! !

!TOUCategory methodsFor: 'testing' stamp: 'OzC 3/19/2012 12:57'!
isTest
	^ false! !

TOUCategory subclass: #TOUEqMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUEqMethods class methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 19:50'!
trackedSelectors 
	^ #(= ~= closeTo: literalEqual: == ~~)! !

!TOUEqMethods methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 19:40'!
doesItComply: expr
 	^ self class trackedSelectors includes: expr methodNode selector
	! !

!TOUEqMethods methodsFor: 'as yet unclassified' stamp: 'OzC 4/11/2012 19:38'!
isEqMethod
	^ true! !

TOUCategory subclass: #TOUForward
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUForward class methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:41'!
trackedSelectors 
	^#()! !

!TOUForward methodsFor: 'as yet unclassified' stamp: 'OzC 3/23/2012 12:42'!
doesItComply: expr
	|parent|
	expr parent isReturn ifTrue: [^true]. 
	parent := expr.
	[ parent:= parent selectFrom: (TOUComplex trackedSelectors).
	parent ifNil: [^ false].
	parent parent isReturn ifTrue: [^ true]] repeat! !

!TOUForward methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:58'!
isForward 
	^ true! !

TOUCategory subclass: #TOUMessageBased
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

TOUMessageBased subclass: #TOUComplex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUComplex class methodsFor: 'as yet unclassified' stamp: 'OzC 3/22/2012 13:54'!
bothSelectors 
	^ #(& and: and:and: and:and:and: and:and:and:and: or: or:or: or:or:or: or:or:or:or: not | ==> xor:
	inlineAnd: inlineAnd:and:  inlineOr:
	and:and:and:and:and:and:and:  )! !

!TOUComplex methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:58'!
isComplex 
	^ true! !

TOUMessageBased subclass: #TOUFlow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUFlow class methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 23:58'!
argumentSelectors 
	^#(doWhileFalse: doWhileTrue:)! !

!TOUFlow class methodsFor: 'as yet unclassified' stamp: 'OzC 3/22/2012 13:20'!
receiverSelectors 
	^#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue: whileTrue: whileFalse: whileTrue whileFalse
	 inlineIfFalse: inlineIfTrue: inlineIfTrue:ifFalse: ) ! !

!TOUFlow methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 00:34'!
doesItComply: expr
	|result|
	result := super doesItComply: expr.
	(expr isMessage and: ['if*' match: expr selector]) ifTrue: [^ true].
	^ result ! !

!TOUFlow methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:58'!
isFlow 
	^ true! !

TOUMessageBased subclass: #TOUHighOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUHighOrder class methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 00:07'!
argument2Selectors  
	^ #( collect:thenSelect: )! !

!TOUHighOrder class methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 12:49'!
argumentSelectors  
	^ #( reject: reject:thenDo: select: select:thenCollect: select:thenDo: anySatisfy:
	   detect: detect:ifNone: noneSatisfy: removeAllSuchThat: contains: allSatisfy:) union: self argument2Selectors! !

!TOUHighOrder methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 00:09'!
discriminateOn: msg
	|msg2|
	msg2:= super discriminateOn: msg.
	(self class argument2Selectors includes: msg selector) ifTrue: [^ msg arguments second].	 
	^ msg2 "for both"		! !

!TOUHighOrder methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:58'!
isHighOrder 
	^ true! !

!TOUMessageBased methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 00:02'!
discriminateOn: msg
	(self class receiverSelectors includes: msg selector) ifTrue: [^ msg receiver].
	(self class argumentSelectors includes: msg selector) ifTrue: [^ msg arguments first].	 
	^ msg "for both"	
	! !

!TOUMessageBased methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 23:34'!
doesItComply: expr
	|parent|
	parent:= expr selectFrom: (self class trackedSelectors) .
	parent ifNil: [^false].
	((self discriminateOn: parent) includesNode: expr) ifFalse: [^false].
	selector := parent selector .
	self extractFrom: expr withParent: parent . 
	^true ! !

!TOUMessageBased methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 23:28'!
extractFrom: expr withParent: parent
	! !

!TOUMessageBased methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 19:25'!
selector 
	^selector ! !

TOUMessageBased subclass: #TOUTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-UCatg'!

!TOUTest class methodsFor: 'as yet unclassified' stamp: 'OzC 3/20/2012 12:27'!
argumentSelectors 
	^#( assert:  assert:description:  assert:description:resumable: 
	deny:  deny:description:  deny:description:resumable:
	should:  shouldnt:  should:description:  shouldnt:description:)! !

!TOUTest class methodsFor: 'as yet unclassified' stamp: 'OzC 3/22/2012 13:43'!
bothSelectors 
	^ #( returns:  )! !

!TOUTest class methodsFor: 'as yet unclassified' stamp: 'OzC 3/22/2012 13:43'!
receiverSelectors 
	^#( should assert shouldnt deny )! !

!TOUTest methodsFor: 'as yet unclassified' stamp: 'OzC 3/22/2012 13:15'!
doesItComply: expr
	|result parent|
	result := super doesItComply: expr.
	parent := expr parent.
	(parent isMessage and: [#( should assert shouldnt deny returns:) includes: parent selector]) ifTrue: [^ true].
	^ result ! !

!TOUTest methodsFor: 'as yet unclassified' stamp: 'OzC 3/19/2012 12:58'!
isTest
	^ true! !

Object subclass: #TOYAbstractDataLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

!TOYAbstractDataLine class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 15:30'!
loadFromLine: line
	|tokens depcls|
	tokens := (line findTokens: ',') collect: [:token| token trimBoth].
	depcls := self allFinalSubclasses detect: [:subcls | subcls tag = tokens first] ifNone: [^nil].
	tokens removeFirst.
	^ depcls newFromTokens: tokens  ! !

!TOYAbstractDataLine class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:26'!
newFromTokens: tokens  
	^ self subclassResponsability! !

!TOYAbstractDataLine class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:26'!
tag
	^ self subclassResponsability.	! !

TOYAbstractDataLine subclass: #TOYDependency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

TOYDependency subclass: #TOYDepClass
	instanceVariableNames: 'clsNames singleClsNames multipleClsNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

!TOYDepClass class methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:54'!
newFromTokens: tokens
	|dep|.
	dep := self new.
	dep clsNames addAll: (tokens collect: [:tk | tk trimBoth] thenSelect: [:tk| tk isClassName]).
	^ dep
	! !

!TOYDepClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:11'!
clsNames
	^ clsNames! !

!TOYDepClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:11'!
initialize
	super initialize.
	clsNames := Set new.! !

!TOYDepClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/6/2012 11:59'!
missingClsNames
	^ self clsNames reject: [:cn | 
			(self singleClsNames includes: cn) or: [self multipleClsNames includes: cn]]! !

!TOYDepClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/6/2012 12:07'!
multipleClsNames
	^ multipleClsNames ifNil: [multipleClsNames:=Set new]! !

!TOYDepClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/6/2012 11:58'!
singleClsNames
	^ singleClsNames ifNil: [singleClsNames:=Set new]! !

TOYDepClass subclass: #TOYDepMCClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

!TOYDepMCClass class methodsFor: 'as yet unclassified' stamp: 'OzC 8/4/2012 16:37'!
tag
	^ 'missing-cls'! !

!TOYDepMCClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:15'!
isDepMCClass
	^ true! !

TOYDepClass subclass: #TOYDepWRClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

!TOYDepWRClass class methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:40'!
tag
	^ 'warns-cls'! !

!TOYDepWRClass methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 02:15'!
isDepWRClass
	^ true! !

TOYDependency subclass: #TOYDepMCPackage
	instanceVariableNames: 'mcName pkgName subPkgName stillMissing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

!TOYDepMCPackage class methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 03:16'!
newFromTokens: tokens
	|dep|
	self assert: tokens size = 1.
	dep := self new.
	dep mcName: tokens first trimBoth.
	dep subPkgName: (dep mcName copyUpToLast: $-) .
	dep pkgName: (dep mcName copyUpTo: $-) .
	^ dep
	! !

!TOYDepMCPackage class methodsFor: 'as yet unclassified' stamp: 'OzC 8/4/2012 16:35'!
tag
	^  'missing-dep'! !

!TOYDepMCPackage methodsFor: 'as yet unclassified' stamp: 'OzC 8/5/2012 03:12'!
isDepMCPackage
	^ true! !

!TOYDepMCPackage methodsFor: 'as yet unclassified' stamp: 'OzC 8/6/2012 11:00'!
isStillMissing
	stillMissing ifNil: [^ true].
	^ stillMissing! !

!TOYDepMCPackage methodsFor: 'as yet unclassified' stamp: 'OzC 8/6/2012 10:59'!
markMissing
	stillMissing := true.! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 02:07'!
mcName

	^ mcName! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 02:07'!
mcName: anObject

	mcName := anObject! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 02:07'!
pkgName

	^ pkgName! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 02:07'!
pkgName: anObject

	pkgName := anObject! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 03:15'!
subPkgName

	^ subPkgName! !

!TOYDepMCPackage methodsFor: 'accessing' stamp: 'OzC 8/5/2012 03:15'!
subPkgName: anObject

	subPkgName := anObject! !

!TOYDependency methodsFor: 'testing' stamp: 'OzC 8/5/2012 02:14'!
isDepMCClass
	^ false! !

!TOYDependency methodsFor: 'testing' stamp: 'OzC 8/5/2012 02:13'!
isDepMCPackage
	^ false! !

!TOYDependency methodsFor: 'testing' stamp: 'OzC 8/5/2012 02:14'!
isDepWRClass
	^ false! !

TOYAbstractDataLine subclass: #TOYRData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRData methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:28'!
isRGlobal
	^ false! !

!TOYRData methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:29'!
isRPredicate
	^ false! !

!TOYRData methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:29'!
isRProject
	^ false! !

TOYRData subclass: #TOYRGlobal
	instanceVariableNames: 'nloc ncls nmth unitRunCount unitPassedCount unitFailureCount unitErrorCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRGlobal class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:52'!
newFromTokens: tokens
	^ self new 	nloc: tokens first asNumber;
				ncls: tokens second asNumber;
				nmth: tokens third asNumber;
				unitRunCount: tokens fourth asNumber;
				unitPassedCount:  (tokens at: 5) asNumber;
				unitFailureCount:  (tokens at: 6) asNumber;
				unitErrorCount:  (tokens at: 7) asNumber! !

!TOYRGlobal class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:29'!
tag
	^ #global! !

!TOYRGlobal methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:29'!
isRGlobal 
	^ true! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
ncls
	^ ncls! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
ncls: anObject
	ncls := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
nloc
	^ nloc! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
nloc: anObject
	nloc := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
nmth
	^ nmth! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
nmth: anObject
	nmth := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitErrorCount
	^ unitErrorCount! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitErrorCount: anObject
	unitErrorCount := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitFailureCount
	^ unitFailureCount! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitFailureCount: anObject
	unitFailureCount := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitPassedCount
	^ unitPassedCount! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitPassedCount: anObject
	unitPassedCount := anObject! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitRunCount
	^ unitRunCount! !

!TOYRGlobal methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:31'!
unitRunCount: anObject
	unitRunCount := anObject! !

TOYRData subclass: #TOYRPredicate
	instanceVariableNames: 'selector defClsName nexec staticRBool rBool isCtt isCttPerRecv sideEffect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRPredicate class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 12:41'!
newFromTokens: tokens
	|neo|
	neo:= self new selector:  tokens first trimBoth ;
					defClsName: tokens second trimBoth  ;
					nexec: tokens third asNumber .
	(tokens size > 3) ifTrue: [
		neo staticRBool: tokens fourth = 'true'.
		neo rBool: (tokens at: 5) = 'true'.
		neo isCtt: (tokens at: 6) = 'true'.
		neo isCttPerRecv: (tokens at: 7) = 'true'.
		neo sideEffect: (tokens at: 8) = 'true'].
	^ neo! !

!TOYRPredicate class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:43'!
tag
	^ #pred! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:36'!
defClsName 
	^ defClsName ! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:36'!
defClsName: cls
	 defClsName := cls! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 15:51'!
hasBeenExecuted 
	^ nexec > 0! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
isCtt
	^ isCtt! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
isCtt: anObject
	isCtt := anObject! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
isCttPerRecv
	^ isCttPerRecv! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
isCttPerRecv: anObject
	isCttPerRecv := anObject! !

!TOYRPredicate methodsFor: 'testing-purity' stamp: 'OzC 8/16/2012 01:04'!
isDynPure
	^ self isPure not & isCtt  & rBool ! !

!TOYRPredicate methodsFor: 'testing-purity' stamp: 'OzC 8/16/2012 01:06'!
isDynPurePerRecv
	^ self isPure not & self isDynPure not 
	& isCttPerRecv  & rBool ! !

!TOYRPredicate methodsFor: 'testing-purity' stamp: 'OzC 8/16/2012 01:01'!
isImpure
	^ isCttPerRecv not & rBool ! !

!TOYRPredicate methodsFor: 'testing-purity' stamp: 'OzC 8/16/2012 00:47'!
isPure
	^  staticRBool "& rBool &  isCtt"! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:44'!
isRPredicate 
	^ true! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
nexec
	^ nexec! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
nexec: anObject
	nexec := anObject! !

!TOYRPredicate methodsFor: 'testing-purity' stamp: 'OzC 8/16/2012 00:53'!
notPredicate
	^ rBool not! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/16/2012 01:46'!
printOn: stream
	stream nextPutAll:  defClsName , '>>' , selector , ' - '  , nexec printString ! !

!TOYRPredicate methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:10'!
printString
	^ defClsName , '>>' , selector , ' - '  , nexec printString ! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
rBool
	^ rBool! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
rBool: anObject
	rBool := anObject! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
selector
	^ selector! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
selector: anObject
	selector := anObject! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
sideEffect
	^ sideEffect! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
sideEffect: anObject
	sideEffect := anObject! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
staticRBool
	^ staticRBool! !

!TOYRPredicate methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:35'!
staticRBool: anObject
	staticRBool := anObject! !

TOYRData subclass: #TOYRProject
	instanceVariableNames: 'projectName global predicates nFiles nLFiles nUFiles emsg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRProject class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 15:46'!
newFromTokens: tokens
	|neo|
	neo:= self new projectName: tokens first trimBoth. 
	tokens size = 2 ifTrue: [ ^ neo emsg:  (TOYRError new msg: 'crash-vm') ].
	^ neo		nFiles: tokens second asNumber ;
				nLFiles: tokens third asNumber ;
				nUFiles: tokens fourth asNumber ! !

!TOYRProject class methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:43'!
tag
	^ #project! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 17:39'!
coverage
	^ (predicates select: #hasBeenExecuted) size / predicates size ! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:05'!
coverageOf: selector 
	|preds|
	predicates ifNil: [self error: 'Not predicates'].
	preds := predicates select: [:pred| selector = pred selector ].
	^ (preds select: #hasBeenExecuted) size / preds size ! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 15:45'!
emsg
	^ emsg ! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 15:46'!
emsg: str
	emsg := str! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:21'!
filterPredicatesWithLessCoverage: coverage 
	|neo|
	self hasPredicates ifFalse:  [^ nil].
	neo:=  self class new.
	neo projectName: (self projectName) ;
		nFiles: (self nFiles ) ;
		nLFiles: (self nLFiles);
		nUFiles: (self nUFiles);
		global: self global.
	self predicates do: [:pred|
		(coverage <= (self coverageOf: pred selector)) ifTrue: [
			neo predicates add: pred]].
	^ neo 	
	! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:13'!
global
	^ global! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:13'!
global: anObject
	global := anObject! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/15/2012 23:21'!
hasPredicates
	^ predicates notNil ! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 15:51'!
hasValidPredicates
	^ predicates notNil and: [predicates anySatisfy: [:pred| pred hasBeenExecuted ] ]! !

!TOYRProject methodsFor: 'purity-filters' stamp: 'OzC 8/16/2012 01:17'!
impurePredicateNames
	^ self selectPredicateNames: #isImpure! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:45'!
isRProject
	^ true! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nFiles
	^ nFiles! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nFiles: anObject
	nFiles := anObject! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nLFiles
	^ nLFiles! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nLFiles: anObject
	nLFiles := anObject! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nUFiles
	^ nUFiles! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:40'!
nUFiles: anObject
	nUFiles := anObject! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/16/2012 01:11'!
predicateNames
	^ (self predicates collect: #selector) asSet ! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 11:15'!
predicates
	^ predicates ifNil: [predicates := OrderedCollection new]! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 17:52'!
predicatesCoverage
	|dict|
	dict:= Dictionary newFrom: ((predicates collect: #selector) asSet collect: [:pred| pred -> 0]).
	dict keysDo: [:pred| |ps|
		ps := predicates select: [:p| p selector = pred].
		dict at: pred put:  ((ps select: #hasBeenExecuted) size / ps size ).
			 ].
	
      ^ dict! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/15/2012 23:09'!
printString 
	^ projectName , ': ' , nLFiles printString , ' - ' , (predicates ifNil: ['0'] ifNotNil: [predicates size printString])! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:13'!
projectName
	^ projectName! !

!TOYRProject methodsFor: 'accessing' stamp: 'OzC 8/13/2012 11:13'!
projectName: anObject
	projectName := anObject! !

!TOYRProject methodsFor: 'purity-filters' stamp: 'OzC 8/16/2012 01:17'!
purePredicateNames
	^ self selectPredicateNames: #isPure! !

!TOYRProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/13/2012 18:10'!
ratioOfPassedTests
	self global ifNil: [^ 0].
	self global unitRunCount isZero ifTrue: [^0].
	^ (self global unitPassedCount / self global unitRunCount) asFloat ! !

!TOYRProject methodsFor: 'purity-filters' stamp: 'OzC 8/16/2012 01:17'!
selectPredicateNames: condition
	^ self predicateNames select: [:sel | (self predicates select: [:pred| pred selector = sel]) allSatisfy: condition ]! !

Object subclass: #TOYDependencyCache
	instanceVariableNames: 'dependencies references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Dep'!

!TOYDependencyCache methodsFor: 'dependencies' stamp: 'OzC 8/4/2012 23:11'!
addDependency: dep
	dependencies add: dep.! !

!TOYDependencyCache methodsFor: 'references' stamp: 'OzC 8/6/2012 09:02'!
cleanReferences
	references := nil! !

!TOYDependencyCache methodsFor: 'dependencies' stamp: 'OzC 8/4/2012 23:10'!
dependencies
	^ dependencies! !

!TOYDependencyCache methodsFor: 'dependencies' stamp: 'OzC 8/5/2012 02:53'!
filterDuplicates "return a new one with only three dep"
	|mc wr neo|

	
	"1. put all pkg dep"
	neo:= self class new.
	neo dependencies addAll: (self dependencies select: #isDepMCPackage). 
	
	"between missing-cls"
	mc := TOYDepMCClass new.
	mc clsNames addAll: ((self dependencies select: #isDepMCClass) 
							inject: Set new into: [:ss :dep|
								ss addAll: dep clsNames . ss]).
	mc clsNames notEmpty ifTrue: [neo addDependency: mc].
	
	"cleaning warn-cls"
	wr:= TOYDepWRClass new.
	(self dependencies select: #isDepWRClass) do: [:dep|
		wr clsNames addAll: (dep clsNames reject: [:cn| mc clsNames includes: cn ])].
	wr clsNames notEmpty ifTrue: [neo addDependency: wr].
	
	^ neo. ! !

!TOYDependencyCache methodsFor: 'initialize-release' stamp: 'OzC 8/4/2012 23:10'!
initialize
	super initialize.
	dependencies := OrderedCollection new.! !

!TOYDependencyCache methodsFor: 'references' stamp: 'OzC 8/6/2012 12:09'!
loadClsRefsFrom: clsDict
	|dict deps|
	deps:= self dependencies select: [:d| d isDepMCClass | d isDepWRClass ]. 
	
	dict:= clsDict select: [:ss| ss size = 1].
	deps do: [:dep|
		dep missingClsNames do: [:cn | 
			dict at: cn  ifPresent: [:poys| 
				self references add: poys anyOne.
				dep singleClsNames add: cn]].
		].
	
	dict:= clsDict select: [:ss| ss size > 1].
	deps do: [:dep|
		dep missingClsNames do: [:cn | 
			dict at: cn  ifPresent: [:poys| 
						poys detect: [:poy| 
								self references includes: poy] 
							  ifNone: [ self references addAll: poys. dep multipleClsNames add: cn]
					]].
		].
	
	
	"self select: [:d| d ] thenDo: [:dep|
		toyDict at: dep pkgName ifPresent: [:poy| references add: poy]]"! !

!TOYDependencyCache methodsFor: 'references' stamp: 'OzC 8/6/2012 12:15'!
loadPkgRefsFrom: toyDict
	self dependencies select: #isDepMCPackage thenDo: [:dep|
		toyDict at: dep pkgName ifPresent: [:poy| self references add: poy] ifAbsent:[dep markMissing] ]! !

!TOYDependencyCache methodsFor: 'references' stamp: 'OzC 8/6/2012 08:59'!
references
	^ references ifNil: [references := Set new]! !

Object subclass: #TOYProject
	instanceVariableNames: 'projectName mcVersions installed runnableState testsCount msgErrors dependencyCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

TOYProject class
	instanceVariableNames: 'testProjects'!

TOYProject class
	instanceVariableNames: 'testProjects'!

!TOYProject class methodsFor: 'as yet unclassified' stamp: 'OzC 8/7/2012 13:16'!
log2: line
	FileStream fileNamed: 'dynamic-out.csv' do: [:stream | 
		stream 	setToEnd ; 
				nextPutAll: line withoutQuoting;
				nextPut: Character cr]! !

!TOYProject class methodsFor: 'as yet unclassified' stamp: 'OzC 7/30/2012 07:23'!
log: line
	FileStream fileNamed: 'general-out.csv' do: [:stream | 
		stream 	setToEnd ; 
				nextPutAll: line withoutQuoting;
				nextPut: Character cr]! !

!TOYProject class methodsFor: 'as yet unclassified' stamp: 'OzC 7/25/2012 16:18'!
newFrom: versions
	|inst|
	inst := (self new).
	inst mcversions addAll: versions.
	^ inst! !

!TOYProject class methodsFor: 'as yet unclassified' stamp: 'OzC 2/4/2013 01:51'!
testProjects
	^ testProjects ifNil: [testProjects := Dictionary new]! !

!TOYProject class methodsFor: 'as yet unclassified' stamp: 'OzC 2/4/2013 03:46'!
testProjects: dict
	testProjects := dict! !

!TOYProject methodsFor: 'comparing' stamp: 'OzC 7/27/2012 01:10'!
<= other
	^ self projectName <= other projectName! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/4/2012 09:14'!
addError: anError
	msgErrors add: anError printString.! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 2/4/2013 00:05'!
addMCVersion: mcVersion
	testsCount := testsCount + mcVersion testClasses size.
	self mcVersions add: mcVersion .! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 8/4/2012 09:16'!
basicInfo
	^ ({ runnableState .
	self projectName .
	self testsCount printString .
	self msgError }) asCommaString withoutQuoting! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 07:51'!
dependencyCache
	^ dependencyCache! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/6/2012 07:52'!
dependencyCache: cache
	dependencyCache := cache! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 18:20'!
ditAvgMax
	|len|
	len:= mcVersions size.
	^ mcVersions inject: {0 . 0} into: [:acc :mcVersion | |dit|
		dit:= mcVersion ditAvgMax.
		{(acc first + dit first) / len asFloat .  acc second max: dit second}] ! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/7/2012 08:35'!
flatReferences
	^ self flatReferencesOn: Set new.! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/7/2012 08:32'!
flatReferencesOn: refs
	|counter flat|
	self isRunnable ifFalse: [^ refs].
	
	counter := 0.
	flat:= Set new.
	self dependencyCache references do: [:ref| 
		(refs includes: ref) ifFalse: [
			flat add: ref. 
			counter:= counter + 1]].
	counter isZero ifTrue:[^ refs].
	
	refs addAll: flat.
	flat do: [:fa| fa flatReferencesOn: refs].
	
	^refs! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/9/2012 07:24'!
flatReferencesOn: refs withLevels: levels
	|counter flat |
	self isRunnable ifFalse: [^ self].
	
	counter := 0.
	flat:= Set new.
	self dependencyCache references do: [:ref| 
		(refs includes: ref) ifFalse: [
			flat add: ref. 
			counter:= counter + 1]].
	counter isZero ifTrue:[^self].
	
	refs addAll: flat.
	levels add: (Array newFrom: (flat collect: [:f | f projectName]) asArray).
	flat do: [:fa| fa flatReferencesOn: refs withLevels: levels].
	
	! !

!TOYProject methodsFor: 'dependencies' stamp: 'OzC 8/9/2012 07:43'!
flatReferencesWithLevels
	|refs levels|
	refs:= Set new.
	levels := OrderedCollection new.
	self flatReferencesOn: refs withLevels: levels.
	
	^ Dictionary newFrom: {
		#references -> (Dictionary newFrom: (refs collect: [:ref| ref projectName -> ref])). 
		#levels -> levels} ! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 18:15'!
genInfoMetrics
	|dit|
	dit := self ditAvgMax.
	^{ projectName . self numberOfMethods . self numberOfClasses . self nloc. dit first . dit second . self lastCommit }
	! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 7/30/2012 07:45'!
generalLog: line
	self class log: line! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 12/6/2012 00:01'!
hasTests
	^ testsCount > 0! !

!TOYProject methodsFor: 'comparing' stamp: 'OzC 8/6/2012 11:45'!
hash
	^ self projectName hash + self dependencyCache hash + self mcVersions hash! !

!TOYProject methodsFor: 'initialize-release' stamp: 'OzC 8/5/2012 01:00'!
initialize
	super initialize.
	runnableState := 'loaded'.
	testsCount := 0.! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 12/6/2012 00:16'!
isInTop1000 
	^ FSource cachedPkgCtg includesKey: projectName ! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/26/2012 07:31'!
isInstalled
	^ installed ifNil: 
		[self markInstalled]
	! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 8/6/2012 08:15'!
isRunnable
	^ (dependencyCache ~= nil) & (testsCount > 0)! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 18:25'!
lastCommit
	^ mcVersions inject: (DateAndTime epoch asDate) into: [:acc :mcVersion | 
		acc max: mcVersion info date] ! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/26/2012 11:33'!
load
	|loaded|
      loaded:=0.
	self mcVersions do: [:mcv|
		[mcv load] on: Error do: [loaded:= loaded + 1]].
	loaded = self mcVersions size ifTrue: [
		runnableState:= 'unloadable'.
		self logState.
		self unload.
		^ false].
	runnableState:= loaded = 0 ifTrue: ['loaded'] ifFalse: ['partially-loaded'].
	^true.! !

!TOYProject methodsFor: 'logging' stamp: 'OzC 7/30/2012 07:49'!
log: line
	FileStream fileNamed: 'dynamic-out.csv' do: [:stream | 
		stream 	setToEnd ; 
				nextPutAll: self basicInfo ;
				nextPutAll: line withoutQuoting;
				nextPut: Character cr]! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 7/27/2012 23:40'!
logState
	self log: ''! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 8/9/2012 09:12'!
markInstalled
	installed := (SystemOrganization categoriesMatching: (self projectName, '*')) notEmpty.
	installed ifTrue: [runnableState:= 'installed']	! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 7/25/2012 16:23'!
mcVersions
	^mcVersions ifNil: [mcVersions := OrderedCollection new]! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 8/4/2012 09:16'!
msgError
	^ msgErrors asCommaString withoutQuoting! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 8/4/2012 09:13'!
msgErrors
	^ msgErrors ifNil: [msgErrors:= Set new].! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 9/9/2013 18:16'!
nloc
	^ mcVersions inject: 0 into: [:acc :mcVersion | acc + mcVersion nolc] ! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 12/6/2012 00:24'!
numberOfClasses
	^ mcVersions inject: 0 into: [:acc :mcVersion | acc + mcVersion allClassDef size] ! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 2/14/2013 01:48'!
numberOfMethods
	^ mcVersions inject: 0 into: [:acc :mcVersion | acc + mcVersion selectorNames size] ! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 12/6/2012 00:21'!
numberOfTestmethods
	^ mcVersions inject: 0 into: [:acc :mcVersion | acc + mcVersion testMethods size] ! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 8/4/2012 09:09'!
preLoad
	|loaded ws|
      loaded:=0.
	ws := Set new.
	
	self mcVersions do: [:mcv|
		[
		  [ [ mcv load ] valueSupplyingAnswer: true	"in some cases is better to say no"
		  ] on: Warning do: [:warn | 
		         (warn isKindOf: UndeclaredVariableWarning) ifTrue: [ws add: warn freeVariableName]. 
		         warn resume]
		] on: Error do: [:err|
		self addError: err.
		loaded:= loaded + 1]].

      ws notEmpty ifTrue: [self generalLog: ('warns-cls , ', ws asCommaString withoutQuoting)].

	loaded = self mcVersions size ifTrue: [
		runnableState:= 'unloadable'.
		self generalLog: self basicInfo.
		"self unload."
		^ false].
	
	runnableState:= loaded = 0 ifTrue: ['loaded'] ifFalse: ['partially-loaded'].
	self generalLog: self basicInfo.
	^true.! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/30/2012 08:05'!
preRun
	self isInstalled ifTrue: [ self generalLog: self basicInfo. ^self].
	self preLoad.
	self unload.! !

!TOYProject methodsFor: 'printing' stamp: 'OzC 2/4/2013 01:01'!
printOn: stream
	stream nextPutAll:  (self projectName,' -> '
		, (self mcVersions size asString),' mczs, '
		, (testsCount asString),' tests')! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 7/25/2012 16:55'!
projectName
	^ projectName ifNil: [^'']
	! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 7/25/2012 16:54'!
projectName: str
	projectName:=str
	! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 2/4/2013 00:45'!
ratioOfTestClasses
	^ (testsCount / self numberOfClasses) asFloat! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 2/4/2013 00:05'!
recountTests
	testsCount := 0.
	mcVersions do: [:mcv| testsCount:= testsCount + mcv testClasses size]! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/26/2012 08:15'!
run
	self isInstalled ifTrue: [ self logState. ^self].
	self load ifTrue: [ 
		self runTests.
		self unload.]! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/27/2012 23:39'!
runTests
	|pf|
	pf:=CheckConstantMethods  runTestsForPackagesMatching: self projectName,'*'.
	self log: ( pf reportLine2). ! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 8/7/2012 08:19'!
runnableState
	^ runnableState! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 8/5/2012 00:37'!
runnableState: state
	runnableState := state.! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 01:06'!
serializableProject
	|spoy mcs|
	spoy:= TOYSProject new projectName: self projectName.
	mcs := Set new.
	self flatReferences do: [:poy|
		mcs addAll: poy mcVersions].
	mcs addAll: self mcVersions.
	
	spoy addMCVersions: mcs asArray.
	^ spoy
! !

!TOYProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 08:03'!
serializableProjectWithLevels
	|spoy data refs|
	spoy:= TOYSProject new projectName: self projectName.
	data:= self flatReferencesWithLevels.
	refs := data at: #references.
	refs removeKey: self projectName ifAbsent: [].
	
	(data at: #levels) reverseDo: [:level| |ls|
		ls := OrderedCollection new.
		level do: [:pn | refs at: pn ifPresent: [:ref | ls add: ref]].
		spoy addMCVersions: (ls inject: Set new into: [:ss :poy| 
			ss addAll: (poy mcVersions) ; yourself]) asArray .
		].
	spoy addMCVersions: self mcVersions asArray.
	^ spoy
! !

!TOYProject methodsFor: 'test-analysis' stamp: 'OzC 2/14/2013 01:49'!
staticTestData
	^ {projectName . testsCount . self numberOfClasses . self numberOfTestmethods . self numberOfMethods } ! !

!TOYProject methodsFor: 'accessing' stamp: 'OzC 7/27/2012 23:57'!
testsCount
	^ testsCount ! !

!TOYProject methodsFor: 'runnable' stamp: 'OzC 7/29/2012 09:30'!
unload
	SystemOrganization removeCategoriesMatching: (self projectName,'*').
	Smalltalk garbageCollect! !

Object subclass: #TOYRError
	instanceVariableNames: 'msg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Data'!

!TOYRError methodsFor: 'accessing' stamp: 'OzC 8/13/2012 12:50'!
msg
	^ msg! !

!TOYRError methodsFor: 'accessing' stamp: 'OzC 8/13/2012 12:50'!
msg: anObject
	msg := anObject! !

Object subclass: #TOYSProject
	instanceVariableNames: 'mcVersions projectName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

TOYSProject class
	instanceVariableNames: 'runningInstance'!

TOYSProject class
	instanceVariableNames: 'runningInstance'!

!TOYSProject class methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 20:21'!
runningInstance
	^ runningInstance! !

!TOYSProject class methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 20:21'!
runningInstance: inst
	runningInstance := inst! !

!TOYSProject methodsFor: 'accessing' stamp: 'OzC 8/9/2012 01:03'!
addMCVersions: array
	mcVersions add: array.! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 20:35'!
emergencyQuit
	TOYProject log2: ('project,' , self projectName , ',e-quit').
	Smalltalk quitPrimitive.! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 01:01'!
initialize
	super initialize.
	mcVersions:= OrderedCollection new.! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 11:43'!
load
	|loaded loadBlock count c2|
      loaded:=0.
	count:=0.
	c2:= 0.
	self mcVersions do: [:mcvs|
		mcvs do: [:mcv|
		[ count:= count +1.
		  [ [ 
			mcv isPkgInstalled ifFalse: [ 
				c2 := c2 +1.
				mcv load ] 
		    ] valueSupplyingAnswer: true	"in some cases is better to say no"
		  ] on: Warning do: [:warn |  warn resume]
		] on: Error do: [:err|
		loaded:= loaded + 1]]].

	^ {count . c2 . loaded}! !

!TOYSProject methodsFor: 'test-coverage' stamp: 'OzC 2/4/2013 04:54'!
loadTestPkgs "check non test dep projects!!!!!!"
	(TOYProject testProjects at: self projectName) do: [:pname| |sp|
		sp:= (FLMaterializer materializeFromFileNamed: 'fuels/' , pname , '.fuel').
		sp load.
		]. ! !

!TOYSProject methodsFor: 'accessing' stamp: 'OzC 8/7/2012 11:40'!
mcVersions

	^ mcVersions! !

!TOYSProject methodsFor: 'accessing' stamp: 'OzC 8/7/2012 11:40'!
projectName

	^ projectName! !

!TOYSProject methodsFor: 'accessing' stamp: 'OzC 8/7/2012 11:40'!
projectName: anObject

	projectName := anObject! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 11:45'!
run
	|state line|
	state := self load.
	self runTests.
	TOYProject log2: ('project,' , self projectName , ',' , state asCommaString withoutQuoting)
	! !

!TOYSProject methodsFor: 'test-coverage' stamp: 'OzC 11/20/2012 10:47'!
runHapao
[	|pf| 
	 pf:=HapaoTestCoverage  runTestsForPackagesMatching: self projectName,'*'.
	TOYProject log2: ('global,' , pf reportGlobal asCommaString withoutQuoting).
	TOYProject log2: ('hapao,' , pf reportHapao asCommaString withoutQuoting).
	
] on: Error do: [:er| TOYProject log2: 'error:' , er printString].! !

!TOYSProject methodsFor: 'test-coverage' stamp: 'OzC 2/4/2013 04:28'!
runTestCoverage
	|state line|
	state := self load.
	"self loadTestPkgs."
	self runHapao.
	TOYProject log2: ('project,' , self projectName , ',' , state asCommaString withoutQuoting)! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 11:34'!
runTests
	[|pf| 
	 pf:=CheckConstantMethods  runTestsForPackagesMatching: self projectName,'*'.
	TOYProject log2: ('global,' , pf reportGlobal asCommaString withoutQuoting).
	pf reportByPred do:[ :rp|
		TOYProject log2: ('pred,' , rp asCommaString withoutQuoting)
		]] on: Error do: [:er| TOYProject log2: 'error:' , er printString].

	! !

!TOYSProject methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 08:06'!
serialize
	FLSerializer serialize: self toFileNamed: ('fuels/' , self projectName , '.fuel').  ! !

Object subclass: #TOYScript
	instanceVariableNames: 'vmExec imgPath imgName scriptName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

!TOYScript class methodsFor: 'as yet unclassified' stamp: 'OzC 12/3/2012 16:56'!
defaultPharo1
	^ self new 
			vmExec: Smalltalk imagePath, '/Pharo-1.0.app/Contents/MacOS/Squeak\ VM\ Opt' ;
			imgPath: Smalltalk imagePath ;
			imgName: 'Pharo1.image' ! !

!TOYScript class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 09:34'!
defaultPreLoad
	^ self newWithLocalContext 
			imgName: 'work-preload.image' ;
			scriptName: 'preload.st' .
			! !

!TOYScript class methodsFor: 'as yet unclassified' stamp: 'OzC 8/7/2012 15:21'!
defaultRun
	^ self newStackVMLocalContext 
			imgName: 'work.image' ;
			scriptName: 'run.st' .
			! !

!TOYScript class methodsFor: 'as yet unclassified' stamp: 'OzC 8/7/2012 21:40'!
newStackVMLocalContext
	^ self new 
			vmExec: Smalltalk imagePath, '/Squeak.app/Contents/MacOS/Squeak' ;
			imgPath: Smalltalk imagePath
	
	! !

!TOYScript class methodsFor: 'as yet unclassified' stamp: 'OzC 8/2/2012 08:38'!
newWithLocalContext
	^ self new 
			vmExec: Smalltalk vmFullPath ;
			imgPath: Smalltalk imagePath
	
	! !

!TOYScript methodsFor: 'run' stamp: 'OzC 12/3/2012 16:49'!
commandLine
	^ (self vmExec , ' ' , self imgFullPath ", ' ' , self scriptFullPath"). 
! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:36'!
imgFullPath
	^ self imgPath , '/' , self imgName ! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
imgName

	^ imgName! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
imgName: anObject

	imgName := anObject! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
imgPath

	^ imgPath! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
imgPath: anObject

	imgPath := anObject! !

!TOYScript methodsFor: 'run' stamp: 'OzC 12/3/2012 16:56'!
runAndBlock

(OSProcess waitForCommand: 'rm ',(self imgPath),'/Pharo1.changes') value.
(OSProcess waitForCommand:  'touch ',(self imgPath),'/Pharo1.changes') value. 
	^ (OSProcess waitForCommand: self commandLine) value! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:36'!
scriptFullPath
	^ self imgPath , '/' , self scriptName  ! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
scriptName

	^ scriptName! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
scriptName: anObject

	scriptName := anObject! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
vmExec

	^ vmExec! !

!TOYScript methodsFor: 'accessing' stamp: 'OzC 8/2/2012 08:27'!
vmExec: anObject

	vmExec := anObject! !

Object subclass: #TOYStartUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Dynamic-Core'!

!TOYStartUp class methodsFor: 'as yet unclassified' stamp: 'OzC 8/8/2012 12:10'!
addToStartUp
	Smalltalk addToStartUpList: self! !

!TOYStartUp class methodsFor: 'as yet unclassified' stamp: 'OzC 8/8/2012 12:10'!
removeFromStartUp
	Smalltalk removeFromStartUpList: self! !

!TOYStartUp class methodsFor: 'as yet unclassified' stamp: 'OzC 8/9/2012 11:06'!
startUp
	(FileStream isAFileNamed: 'current.toy') ifTrue:[ 
				
		[ TOYProjectDictionary runNext ] ensure: [ Smalltalk quitPrimitive ]
		
		].! !
